import _defineProperty from '@babel/runtime/helpers/defineProperty';
import _extends from '@babel/runtime/helpers/extends';
import _objectWithoutProperties from '@babel/runtime/helpers/objectWithoutProperties';
import React__default from 'react';
import classnames from 'classnames';
import { n as noop } from './index-C9RIWUPw.js';
import Button from './Button.js';
import Dropdown from './Dropdown.js';
import '@babel/runtime/helpers/slicedToArray';
import '@babel/runtime/helpers/classCallCheck';
import '@babel/runtime/helpers/createClass';
import '@bigbinary/neeto-cist';
import 'qs';
import 'ramda';
import './en-D0AIwLkS.js';
import '@babel/runtime/helpers/toConsumableArray';
import 'dayjs';
import 'dayjs/plugin/localeData';
import 'dayjs/plugin/utc';
import 'dayjs/plugin/weekday';
import 'dayjs/plugin/weekOfYear';
import 'react-router-dom';
import './Spinner.js';
import './Tooltip.js';
import '@tippyjs/react';
import 'tippy.js';
import '@bigbinary/neeto-icons';

var _excluded = ["style", "size"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var BTN_STYLES = {
  primary: "primary",
  secondary: "secondary"
};
var BTN_SIZES = {
  small: "small",
  medium: "medium",
  large: "large"
};
var ActionDropdown = function ActionDropdown(_ref) {
  var _ref$label = _ref.label,
    label = _ref$label === void 0 ? "" : _ref$label,
    _ref$buttonStyle = _ref.buttonStyle,
    buttonStyle = _ref$buttonStyle === void 0 ? BTN_STYLES.primary : _ref$buttonStyle,
    _ref$buttonSize = _ref.buttonSize,
    buttonSize = _ref$buttonSize === void 0 ? BTN_SIZES.medium : _ref$buttonSize,
    _ref$disabled = _ref.disabled,
    disabled = _ref$disabled === void 0 ? false : _ref$disabled,
    _ref$onClick = _ref.onClick,
    onClick = _ref$onClick === void 0 ? noop : _ref$onClick,
    _ref$buttonProps = _ref.buttonProps,
    _ref$buttonProps2 = _ref$buttonProps === void 0 ? {} : _ref$buttonProps,
    style = _ref$buttonProps2.style,
    size = _ref$buttonProps2.size,
    buttonProps = _objectWithoutProperties(_ref$buttonProps2, _excluded),
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? "" : _ref$className,
    dropdownProps = _ref.dropdownProps,
    children = _ref.children,
    portalProps = _ref.portalProps;
  return /*#__PURE__*/React__default.createElement("div", {
    className: classnames(["neeto-ui-action-dropdown", className])
  }, /*#__PURE__*/React__default.createElement(Button, _extends({
    disabled: disabled,
    label: label,
    onClick: onClick,
    "data-cy": "action-dropdown-btn",
    "data-testid": "action-dropdown-btn",
    size: size !== null && size !== void 0 ? size : buttonSize,
    style: style !== null && style !== void 0 ? style : buttonStyle
  }, buttonProps)), /*#__PURE__*/React__default.createElement(Dropdown, _extends({
    disabled: disabled,
    buttonProps: {
      size: size !== null && size !== void 0 ? size : buttonSize
    },
    buttonStyle: style !== null && style !== void 0 ? style : buttonStyle
  }, dropdownProps, {
    dropdownProps: _objectSpread(_objectSpread({}, dropdownProps === null || dropdownProps === void 0 ? void 0 : dropdownProps.dropdownProps), portalProps)
  }), children));
};
ActionDropdown.Menu = Dropdown.Menu;
ActionDropdown.MenuItem = Dropdown.MenuItem;
ActionDropdown.Divider = Dropdown.Divider;

export { ActionDropdown as default };
//# sourceMappingURL=ActionDropdown.js.map
