import _defineProperty from '@babel/runtime/helpers/defineProperty';
import _extends from '@babel/runtime/helpers/extends';
import _slicedToArray from '@babel/runtime/helpers/slicedToArray';
import _objectWithoutProperties from '@babel/runtime/helpers/objectWithoutProperties';
import React__default, { forwardRef, useState } from 'react';
import classnames from 'classnames';
import { replace } from 'ramda';
import { u as useId } from './useId-Jj9hXm-g.js';
import 'react-router-dom';
import '@bigbinary/neeto-hotkeys';
import './overlayManager.js';
import { h as hyphenize } from './index-C9RIWUPw.js';
import 'qs';
import Label from './Label.js';
import '@babel/runtime/helpers/classCallCheck';
import '@babel/runtime/helpers/createClass';
import '@bigbinary/neeto-cist';
import './en-D0AIwLkS.js';
import '@babel/runtime/helpers/toConsumableArray';
import 'dayjs';
import 'dayjs/plugin/localeData';
import 'dayjs/plugin/utc';
import 'dayjs/plugin/weekday';
import 'dayjs/plugin/weekOfYear';
import '@bigbinary/neeto-icons';
import './Button.js';
import './Spinner.js';
import './Tooltip.js';
import '@tippyjs/react';
import 'tippy.js';
import './Popover.js';
import './Typography.js';

var _excluded = ["size", "type", "label", "dataCy", "error", "suffix", "prefix", "disabled", "helpText", "className", "nakedInput", "contentSize", "required", "maxLength", "unlimitedChars", "labelProps", "rejectCharsRegex", "onBlur", "disableTrimOnBlur"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var SIZES = {
  small: "small",
  medium: "medium",
  large: "large"
};
var Input = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref2, _otherProps$value;
  var _ref$size = _ref.size,
    size = _ref$size === void 0 ? SIZES.medium : _ref$size,
    _ref$type = _ref.type,
    type = _ref$type === void 0 ? "text" : _ref$type,
    _ref$label = _ref.label,
    label = _ref$label === void 0 ? "" : _ref$label,
    _ref$dataCy = _ref.dataCy,
    dataCy = _ref$dataCy === void 0 ? "" : _ref$dataCy,
    _ref$error = _ref.error,
    error = _ref$error === void 0 ? "" : _ref$error,
    _ref$suffix = _ref.suffix,
    suffix = _ref$suffix === void 0 ? null : _ref$suffix,
    _ref$prefix = _ref.prefix,
    prefix = _ref$prefix === void 0 ? null : _ref$prefix,
    _ref$disabled = _ref.disabled,
    disabled = _ref$disabled === void 0 ? false : _ref$disabled,
    _ref$helpText = _ref.helpText,
    helpText = _ref$helpText === void 0 ? "" : _ref$helpText,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? "" : _ref$className,
    _ref$nakedInput = _ref.nakedInput,
    nakedInput = _ref$nakedInput === void 0 ? false : _ref$nakedInput,
    _ref$contentSize = _ref.contentSize,
    contentSize = _ref$contentSize === void 0 ? null : _ref$contentSize,
    _ref$required = _ref.required,
    required = _ref$required === void 0 ? false : _ref$required,
    maxLength = _ref.maxLength,
    _ref$unlimitedChars = _ref.unlimitedChars,
    unlimitedChars = _ref$unlimitedChars === void 0 ? false : _ref$unlimitedChars,
    labelProps = _ref.labelProps,
    rejectCharsRegex = _ref.rejectCharsRegex,
    onBlur = _ref.onBlur,
    _ref$disableTrimOnBlu = _ref.disableTrimOnBlur,
    disableTrimOnBlur = _ref$disableTrimOnBlu === void 0 ? false : _ref$disableTrimOnBlu,
    otherProps = _objectWithoutProperties(_ref, _excluded);
  var _useState = useState(otherProps.value),
    _useState2 = _slicedToArray(_useState, 2),
    valueInternal = _useState2[0],
    setValueInternal = _useState2[1];
  var id = useId(otherProps.id);
  var errorId = "error_".concat(id);
  var helpTextId = "helpText_".concat(id);
  var value = (_ref2 = (_otherProps$value = otherProps.value) !== null && _otherProps$value !== void 0 ? _otherProps$value : valueInternal) !== null && _ref2 !== void 0 ? _ref2 : "";
  var valueLength = (value === null || value === void 0 ? void 0 : value.toString().length) || 0;
  var isCharacterLimitVisible = valueLength >= maxLength * 0.85;
  var maxLengthError = unlimitedChars && valueLength > maxLength;
  var onChange = function onChange(e) {
    var _otherProps$onChange;
    if (!otherProps.onChange || !otherProps.value) {
      setValueInternal(e.target.value);
    }
    (_otherProps$onChange = otherProps.onChange) === null || _otherProps$onChange === void 0 || _otherProps$onChange.call(otherProps, e);
  };
  var isMaxLengthPresent = !!maxLength || maxLength === 0;
  var handleRegexChange = function handleRegexChange(e) {
    var globalRegex = new RegExp(rejectCharsRegex, "g");
    e.target.value = replace(globalRegex, "", e.target.value);
    onChange(e);
  };
  var handleChange = rejectCharsRegex ? handleRegexChange : onChange;
  var handleTrimmedChangeOnBlur = function handleTrimmedChangeOnBlur(e) {
    if (disableTrimOnBlur || typeof value !== "string") return;
    var trimmedValue = value.trim();
    if (value === trimmedValue) return;
    e.target.value = trimmedValue;
    handleChange(e);
  };
  var handleOnBlur = function handleOnBlur(e) {
    handleTrimmedChangeOnBlur(e);
    onBlur === null || onBlur === void 0 || onBlur(e);
  };
  var dataCyLabel = typeof label === "string" ? hyphenize(label) : hyphenize(dataCy);
  return /*#__PURE__*/React__default.createElement("div", {
    className: classnames(["neeto-ui-input__wrapper", className])
  }, /*#__PURE__*/React__default.createElement("div", {
    className: "neeto-ui-input__label-wrapper"
  }, label && /*#__PURE__*/React__default.createElement(Label, _extends({
    required: required,
    "data-cy": "".concat(dataCyLabel, "-input-label"),
    htmlFor: id
  }, labelProps), label), isCharacterLimitVisible && /*#__PURE__*/React__default.createElement("p", {
    className: classnames("neeto-ui-input__max-length", {
      "neeto-ui-input__max-length--error": maxLengthError
    })
  }, valueLength, "/", maxLength)), /*#__PURE__*/React__default.createElement("div", {
    "data-cy": "".concat(dataCyLabel, "-input"),
    className: classnames("neeto-ui-input", {
      "neeto-ui-input--naked": !!nakedInput,
      "neeto-ui-input--error": !!error,
      "neeto-ui-input--disabled": !!disabled,
      "neeto-ui-input--small": size === "small",
      "neeto-ui-input--medium": size === "medium",
      "neeto-ui-input--large": size === "large"
    })
  }, prefix && /*#__PURE__*/React__default.createElement("div", {
    className: "neeto-ui-input__prefix"
  }, prefix), /*#__PURE__*/React__default.createElement("input", _extends({
    "aria-invalid": !!error,
    "data-cy": "".concat(dataCyLabel, "-input-field"),
    size: contentSize,
    "aria-describedby": classnames(_defineProperty(_defineProperty({}, errorId, !!error), helpTextId, helpText))
  }, _objectSpread(_objectSpread(_objectSpread({
    disabled: disabled,
    id: id,
    ref: ref,
    required: required,
    type: type
  }, isMaxLengthPresent && !unlimitedChars && {
    maxLength: maxLength
  }), otherProps), {}, {
    value: value
  }), {
    onBlur: handleOnBlur,
    onChange: handleChange
  })), suffix && /*#__PURE__*/React__default.createElement("div", {
    className: "neeto-ui-input__suffix"
  }, suffix)), !!error && /*#__PURE__*/React__default.createElement("p", {
    className: "neeto-ui-input__error",
    "data-cy": "".concat(dataCyLabel, "-input-error"),
    id: errorId
  }, error), helpText && /*#__PURE__*/React__default.createElement("p", {
    className: "neeto-ui-input__help-text",
    "data-cy": "".concat(dataCyLabel, "-input-help"),
    id: helpTextId
  }, helpText));
});
Input.displayName = "Input";

export { Input as default };
//# sourceMappingURL=Input.js.map
