import _extends from '@babel/runtime/helpers/extends';
import _objectWithoutProperties from '@babel/runtime/helpers/objectWithoutProperties';
import React__default, { forwardRef, useRef } from 'react';
import classnames from 'classnames';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import { Help } from '@bigbinary/neeto-icons';
import Button from './Button.js';
import Popover from './Popover.js';
import Tooltip from './Tooltip.js';
import Typography from './Typography.js';
import '@babel/runtime/helpers/slicedToArray';
import '@tippyjs/react';
import 'tippy.js';
import 'react-router-dom';
import './Spinner.js';

var _excluded$2 = ["onClick", "className", "icon"];
var HelpIcon = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var onClick = _ref.onClick,
    className = _ref.className,
    icon = _ref.icon,
    otherProps = _objectWithoutProperties(_ref, _excluded$2);
  var HelpIcon = icon || Help;
  return /*#__PURE__*/React__default.createElement("span", {
    onClick: onClick,
    ref: ref,
    className: classnames("neeto-ui-label__help-icon-wrap", _defineProperty({}, className, className))
  }, /*#__PURE__*/React__default.createElement(HelpIcon, _extends({
    size: 16
  }, otherProps)));
});
HelpIcon.displayName = "HelpIcon";

var _excluded$1 = ["tooltipProps", "popoverProps"],
  _excluded2 = ["title", "description", "helpLinkProps"];
var HelpContent = function HelpContent(_ref) {
  var helpIconProps = _ref.helpIconProps;
  var popoverReferenceElement = useRef();
  var _ref2 = helpIconProps || {},
    tooltipProps = _ref2.tooltipProps,
    popoverProps = _ref2.popoverProps,
    otherHelpIconProps = _objectWithoutProperties(_ref2, _excluded$1);
  if (tooltipProps) {
    return /*#__PURE__*/React__default.createElement(Tooltip, tooltipProps, /*#__PURE__*/React__default.createElement(HelpIcon, otherHelpIconProps));
  }
  if (popoverProps) {
    var title = popoverProps.title,
      description = popoverProps.description,
      helpLinkProps = popoverProps.helpLinkProps,
      otherPopoverProps = _objectWithoutProperties(popoverProps, _excluded2);
    return /*#__PURE__*/React__default.createElement(React__default.Fragment, null, /*#__PURE__*/React__default.createElement(HelpIcon, _extends({}, otherHelpIconProps, {
      ref: popoverReferenceElement
    })), /*#__PURE__*/React__default.createElement(Popover, _extends({
      reference: popoverReferenceElement
    }, otherPopoverProps), /*#__PURE__*/React__default.createElement("div", {
      className: "neeto-ui-flex neeto-ui-flex-col"
    }, title && /*#__PURE__*/React__default.createElement(Popover.Title, {
      "data-cy": "help-popover-title",
      "data-testid": "help-popover-title"
    }, title), typeof description === "string" ? /*#__PURE__*/React__default.createElement(Typography, {
      "data-cy": "help-popover-description",
      "data-testid": "help-popover-description",
      lineHeight: "normal",
      style: "body2",
      weight: "normal"
    }, description) : description, helpLinkProps && /*#__PURE__*/React__default.createElement(Button, _extends({
      className: "neeto-ui-mt-3",
      "data-cy": "help-popover-link-button",
      size: "small"
    }, helpLinkProps, {
      "data-testid": "help-popover-link-button",
      style: "link",
      target: "_blank"
    })))));
  }
  return /*#__PURE__*/React__default.createElement(HelpIcon, otherHelpIconProps);
};

var _excluded = ["children", "className", "required", "helpIconProps"];
var Label = function Label(_ref) {
  var children = _ref.children,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? "" : _ref$className,
    _ref$required = _ref.required,
    required = _ref$required === void 0 ? false : _ref$required,
    _ref$helpIconProps = _ref.helpIconProps,
    helpIconProps = _ref$helpIconProps === void 0 ? null : _ref$helpIconProps,
    props = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/React__default.createElement("label", _extends({
    className: classnames("neeto-ui-label neeto-ui-flex neeto-ui-items-center", className)
  }, props), children, required && /*#__PURE__*/React__default.createElement("span", {
    "aria-hidden": true
  }, "*"), helpIconProps && /*#__PURE__*/React__default.createElement(HelpContent, {
    helpIconProps: helpIconProps
  }));
};

export { Label as default };
//# sourceMappingURL=Label.js.map
