import _extends from '@babel/runtime/helpers/extends';
import _objectWithoutProperties from '@babel/runtime/helpers/objectWithoutProperties';
import React__default from 'react';
import classnames from 'classnames';
import Typography from './Typography.js';
import Tooltip from './Tooltip.js';
import '@babel/runtime/helpers/defineProperty';
import '@babel/runtime/helpers/slicedToArray';
import '@tippyjs/react';
import 'tippy.js';

var Title = function Title(_ref) {
  var className = _ref.className,
    children = _ref.children;
  return /*#__PURE__*/React__default.createElement(Typography, {
    className: classnames("neeto-ui-mb-1", className),
    "data-testid": "popover-title",
    lineHeight: "snug",
    style: "h5",
    weight: "semibold"
  }, children);
};

var _excluded = ["children", "className", "theme"];
var Popover = function Popover(_ref) {
  var children = _ref.children,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? "" : _ref$className,
    _ref$theme = _ref.theme,
    theme = _ref$theme === void 0 ? "light" : _ref$theme,
    otherProps = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/React__default.createElement(Tooltip, _extends({
    theme: theme,
    arrow: true,
    interactive: true,
    className: classnames("neeto-ui-popover", className),
    content: children
  }, otherProps));
};
Popover.Title = Title;

export { Popover as default };
//# sourceMappingURL=Popover.js.map
