import React__default from 'react';
import classnames from 'classnames';
import { motion } from 'framer-motion';

var ProgressBar = function ProgressBar(_ref) {
  var progressPercentage = _ref.progressPercentage,
    progressValue = _ref.progressValue,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? "" : _ref$className;
  return /*#__PURE__*/React__default.createElement("div", {
    className: classnames(["neeto-ui-progress-bar__wrapper neeto-ui-rounded-full", className])
  }, /*#__PURE__*/React__default.createElement(motion.div, {
    animate: {
      width: "".concat(progressPercentage, "%")
    },
    className: "neeto-ui-progress-bar neeto-ui-rounded-full",
    "data-cy": "progress-bar",
    initial: {
      width: 0
    },
    transition: {
      duration: 0.5,
      ease: "easeInOut"
    }
  }, progressValue !== null && progressValue !== void 0 ? progressValue : "".concat(progressPercentage, "%")));
};

export { ProgressBar as default };
//# sourceMappingURL=ProgressBar.js.map
