import _defineProperty from '@babel/runtime/helpers/defineProperty';
import _extends from '@babel/runtime/helpers/extends';
import _slicedToArray from '@babel/runtime/helpers/slicedToArray';
import _objectWithoutProperties from '@babel/runtime/helpers/objectWithoutProperties';
import React__default, { useState, Children, cloneElement } from 'react';
import classnames from 'classnames';
import Label from './Label.js';
import { u as useId } from './useId-Jj9hXm-g.js';
import 'react-router-dom';
import '@bigbinary/neeto-hotkeys';
import './overlayManager.js';
import { h as hyphenize } from './index-C9RIWUPw.js';
import 'qs';
import '@bigbinary/neeto-icons';
import './Button.js';
import './Spinner.js';
import './Tooltip.js';
import '@tippyjs/react';
import 'tippy.js';
import './Popover.js';
import './Typography.js';
import '@babel/runtime/helpers/classCallCheck';
import '@babel/runtime/helpers/createClass';
import '@bigbinary/neeto-cist';
import 'ramda';
import './en-D0AIwLkS.js';
import '@babel/runtime/helpers/toConsumableArray';
import 'dayjs';
import 'dayjs/plugin/localeData';
import 'dayjs/plugin/utc';
import 'dayjs/plugin/weekday';
import 'dayjs/plugin/weekOfYear';

var _excluded$1 = ["name", "label", "className", "labelProps", "dataCy"];
var Item = function Item(_ref) {
  var _ref$name = _ref.name,
    name = _ref$name === void 0 ? "" : _ref$name,
    _ref$label = _ref.label,
    label = _ref$label === void 0 ? "" : _ref$label,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? "" : _ref$className,
    labelProps = _ref.labelProps,
    _ref$dataCy = _ref.dataCy,
    dataCy = _ref$dataCy === void 0 ? "" : _ref$dataCy,
    otherProps = _objectWithoutProperties(_ref, _excluded$1);
  var id = useId(otherProps.id);
  return /*#__PURE__*/React__default.createElement("div", {
    className: classnames(["neeto-ui-radio__item", className])
  }, /*#__PURE__*/React__default.createElement("input", _extends({
    id: id,
    name: name,
    className: "neeto-ui-radio",
    "data-cy": dataCy || "".concat(hyphenize(label), "-radio-input"),
    type: "radio"
  }, otherProps)), label && /*#__PURE__*/React__default.createElement(Label, _extends({
    "data-cy": dataCy || "".concat(hyphenize(label), "-radio-label"),
    htmlFor: id
  }, labelProps), label));
};
Item.displayName = "Radio.Item";

var _excluded = ["label", "children", "stacked", "className", "containerClassName", "error", "onChange", "labelProps"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var Radio = function Radio(_ref) {
  var _ref$label = _ref.label,
    label = _ref$label === void 0 ? "" : _ref$label,
    children = _ref.children,
    _ref$stacked = _ref.stacked,
    stacked = _ref$stacked === void 0 ? false : _ref$stacked,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? "" : _ref$className,
    _ref$containerClassNa = _ref.containerClassName,
    containerClassName = _ref$containerClassNa === void 0 ? "" : _ref$containerClassNa,
    _ref$error = _ref.error,
    error = _ref$error === void 0 ? "" : _ref$error,
    onChange = _ref.onChange,
    labelProps = _ref.labelProps,
    props = _objectWithoutProperties(_ref, _excluded);
  var _useState = useState(""),
    _useState2 = _slicedToArray(_useState, 2),
    internalValue = _useState2[0],
    setInternalValue = _useState2[1];
  var id = useId(props.id);
  var errorId = "error_".concat(id);
  var internalOnChange = function internalOnChange(e) {
    return setInternalValue(e.target.value);
  };
  return /*#__PURE__*/React__default.createElement("div", {
    className: classnames(["neeto-ui-radio__wrapper", className])
  }, label && /*#__PURE__*/React__default.createElement(Label, _extends({
    className: "neeto-ui-radio__label"
  }, labelProps), label), /*#__PURE__*/React__default.createElement("div", {
    className: classnames(["neeto-ui-radio__container"], _defineProperty({
      "neeto-ui-radio__container--stacked": stacked,
      "neeto-ui-radio__container--error": error
    }, containerClassName, containerClassName))
  }, Children.map(children, function (child) {
    var _child$props$checked, _ref2, _child$props$onChange;
    return /*#__PURE__*/cloneElement(child, _objectSpread(_objectSpread(_objectSpread({}, child.props), props), {}, {
      value: child.props.value,
      checked: (_child$props$checked = child.props.checked) !== null && _child$props$checked !== void 0 ? _child$props$checked : [internalValue, props.value].includes(child.props.value),
      onChange: (_ref2 = (_child$props$onChange = child.props.onChange) !== null && _child$props$onChange !== void 0 ? _child$props$onChange : onChange) !== null && _ref2 !== void 0 ? _ref2 : internalOnChange
    }));
  })), !!error && /*#__PURE__*/React__default.createElement("p", {
    className: "neeto-ui-radio-input__error",
    "data-cy": "".concat(hyphenize(label), "-radio-input-error"),
    id: errorId
  }, error));
};
Radio.Item = Item;

export { Radio as default };
//# sourceMappingURL=Radio.js.map
