import _ConfigProvider from 'antd/lib/config-provider';
import _Slider from 'antd/lib/slider';
import _extends from '@babel/runtime/helpers/extends';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import _objectWithoutProperties from '@babel/runtime/helpers/objectWithoutProperties';
import React__default from 'react';
import { useTranslation } from 'react-i18next';
import { ANTD_LOCALE } from './constants.js';
import Label from './Label.js';
import { u as useId } from './useId-Jj9hXm-g.js';
import '@babel/runtime/helpers/slicedToArray';
import 'react-router-dom';
import '@bigbinary/neeto-hotkeys';
import './overlayManager.js';
import { h as hyphenize, n as noop, A as ANT_DESIGN_GLOBAL_TOKEN_OVERRIDES } from './index-C9RIWUPw.js';
import 'qs';
import 'antd/locale/de_DE';
import 'antd/locale/en_US';
import 'antd/locale/es_ES';
import 'antd/locale/fr_FR';
import 'antd/locale/nl_NL';
import 'antd/locale/pl_PL';
import 'antd/locale/pt_PT';
import 'classnames';
import '@bigbinary/neeto-icons';
import './Button.js';
import './Spinner.js';
import './Tooltip.js';
import '@tippyjs/react';
import 'tippy.js';
import './Popover.js';
import './Typography.js';
import '@babel/runtime/helpers/classCallCheck';
import '@babel/runtime/helpers/createClass';
import '@bigbinary/neeto-cist';
import 'ramda';
import './en-D0AIwLkS.js';
import '@babel/runtime/helpers/toConsumableArray';
import 'dayjs';
import 'dayjs/plugin/localeData';
import 'dayjs/plugin/utc';
import 'dayjs/plugin/weekday';
import 'dayjs/plugin/weekOfYear';

var _excluded = ["min", "max", "defaultValue", "onChange", "value", "label", "required", "labelProps", "error", "helpText"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var Slider = function Slider(_ref) {
  var _ref$min = _ref.min,
    min = _ref$min === void 0 ? 0 : _ref$min,
    _ref$max = _ref.max,
    max = _ref$max === void 0 ? 100 : _ref$max,
    _ref$defaultValue = _ref.defaultValue,
    defaultValue = _ref$defaultValue === void 0 ? 0 : _ref$defaultValue,
    _ref$onChange = _ref.onChange,
    onChange = _ref$onChange === void 0 ? noop : _ref$onChange,
    _ref$value = _ref.value,
    value = _ref$value === void 0 ? undefined : _ref$value,
    label = _ref.label,
    _ref$required = _ref.required,
    required = _ref$required === void 0 ? false : _ref$required,
    _ref$labelProps = _ref.labelProps,
    labelProps = _ref$labelProps === void 0 ? {} : _ref$labelProps,
    error = _ref.error,
    helpText = _ref.helpText,
    otherProps = _objectWithoutProperties(_ref, _excluded);
  var id = useId(otherProps.id);
  var errorId = "error_".concat(id);
  var helpTextId = "helpText_".concat(id);
  var _useTranslation = useTranslation(),
    i18n = _useTranslation.i18n;
  return /*#__PURE__*/React__default.createElement(_ConfigProvider, {
    locale: ANTD_LOCALE[i18n.language || "en"],
    theme: {
      token: _objectSpread({}, ANT_DESIGN_GLOBAL_TOKEN_OVERRIDES),
      components: {
        Slider: {
          dotActiveBorderColor: "rgb(var(--neeto-ui-primary-500))",
          dotBorderColor: "rgb(var(--neeto-ui-gray-500))",
          handleActiveColor: "rgb(var(--neeto-ui-primary-600))",
          handleColor: "rgb(var(--neeto-ui-primary-500))",
          railBg: "rgb(var(--neeto-ui-gray-200))",
          railHoverBg: "rgb(var(--neeto-ui-gray-300))",
          trackBg: "rgb(var(--neeto-ui-primary-500))",
          trackBgDisabled: "rgb(var(--neeto-ui-gray-100))",
          trackHoverBg: "rgb(var(--neeto-ui-primary-600))",
          // Global overrides
          colorFillContentHover: "rgb(var(--neeto-ui-gray-600))"
        }
      }
    }
  }, /*#__PURE__*/React__default.createElement("div", {
    className: "neeto-ui-input__wrapper"
  }, /*#__PURE__*/React__default.createElement("div", {
    className: "neeto-ui-input__label-wrapper"
  }, label && /*#__PURE__*/React__default.createElement(Label, _extends({
    required: required,
    "data-cy": "".concat(hyphenize(label), "-slider-label"),
    htmlFor: id
  }, labelProps), label)), /*#__PURE__*/React__default.createElement(_Slider, _extends({
    className: "neeto-ui-w-full",
    tooltip: {
      formatter: null
    }
  }, _objectSpread(_objectSpread({
    defaultValue: defaultValue,
    max: max,
    min: min,
    onChange: onChange,
    value: value
  }, otherProps), {}, {
    id: id
  }))), !!error && /*#__PURE__*/React__default.createElement("p", {
    className: "neeto-ui-input__error",
    "data-cy": "".concat(hyphenize(label), "-input-error"),
    id: errorId
  }, error), helpText && /*#__PURE__*/React__default.createElement("p", {
    className: "neeto-ui-input__help-text",
    "data-cy": "".concat(hyphenize(label), "-input-help"),
    id: helpTextId
  }, helpText)));
};

export { Slider as default };
//# sourceMappingURL=Slider.js.map
