import _ConfigProvider from 'antd/lib/config-provider';
import _Tree from 'antd/lib/tree';
import _extends from '@babel/runtime/helpers/extends';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import _objectWithoutProperties from '@babel/runtime/helpers/objectWithoutProperties';
import React__default from 'react';
import classnames from 'classnames';
import { useTranslation } from 'react-i18next';
import { ANTD_LOCALE } from './constants.js';
import { A as ANT_DESIGN_GLOBAL_TOKEN_OVERRIDES } from './index-C9RIWUPw.js';
import { Down, Right } from '@bigbinary/neeto-icons';
import 'antd/locale/de_DE';
import 'antd/locale/en_US';
import 'antd/locale/es_ES';
import 'antd/locale/fr_FR';
import 'antd/locale/nl_NL';
import 'antd/locale/pl_PL';
import 'antd/locale/pt_PT';
import '@babel/runtime/helpers/slicedToArray';
import '@babel/runtime/helpers/classCallCheck';
import '@babel/runtime/helpers/createClass';
import '@bigbinary/neeto-cist';
import 'qs';
import 'ramda';
import './en-D0AIwLkS.js';
import '@babel/runtime/helpers/toConsumableArray';
import 'dayjs';
import 'dayjs/plugin/localeData';
import 'dayjs/plugin/utc';
import 'dayjs/plugin/weekday';
import 'dayjs/plugin/weekOfYear';

var SwitcherIcon = function SwitcherIcon(_ref) {
  var expanded = _ref.expanded;
  return expanded ? /*#__PURE__*/React__default.createElement(Down, {
    size: 16
  }) : /*#__PURE__*/React__default.createElement(Right, {
    size: 16
  });
};

var _excluded = ["componentToken"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var Tree = function Tree(_ref) {
  var componentToken = _ref.componentToken,
    props = _objectWithoutProperties(_ref, _excluded);
  var _useTranslation = useTranslation(),
    i18n = _useTranslation.i18n;
  return /*#__PURE__*/React__default.createElement(_ConfigProvider, {
    locale: ANTD_LOCALE[i18n.language || "en"],
    theme: {
      token: _objectSpread({}, ANT_DESIGN_GLOBAL_TOKEN_OVERRIDES),
      components: {
        Tree: _objectSpread({
          directoryNodeSelectedBg: "rgb(var(--neeto-ui-primary-500))",
          directoryNodeSelectedColor: "rgb(var(--neeto-ui-white))",
          nodeHoverBg: "rgb(var(--neeto-ui-gray-100))",
          nodeSelectedBg: "rgb(var(--neeto-ui-primary-100))"
        }, componentToken)
      }
    }
  }, /*#__PURE__*/React__default.createElement(_Tree, _extends({
    switcherIcon: SwitcherIcon
  }, props, {
    className: classnames("neeto-ui-tree", props.className)
  })));
};

export { Tree as default };
//# sourceMappingURL=Tree.js.map
