'use strict';

var _extends = require('@babel/runtime/helpers/extends');
var _objectWithoutProperties = require('@babel/runtime/helpers/objectWithoutProperties');
var React = require('react');
var classnames = require('classnames');
var useId = require('./useId-DXHUzdxd.js');
require('@babel/runtime/helpers/slicedToArray');
require('react-router-dom');
require('@bigbinary/neeto-hotkeys');
require('./overlayManager.js');
var index = require('./index-Ci1VcKxO.js');
require('@babel/runtime/helpers/defineProperty');
require('qs');
var Label = require('./Label.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('@bigbinary/neeto-cist');
require('ramda');
require('./en-CPeHe9Ab.js');
require('@babel/runtime/helpers/toConsumableArray');
require('dayjs');
require('dayjs/plugin/localeData');
require('dayjs/plugin/utc');
require('dayjs/plugin/weekday');
require('dayjs/plugin/weekOfYear');
require('@bigbinary/neeto-icons');
require('./Button.js');
require('./Spinner.js');
require('./Tooltip.js');
require('@tippyjs/react');
require('tippy.js');
require('./Popover.js');
require('./Typography.js');

var _excluded = ["label", "error", "className", "required", "labelProps", "children"];
var Checkbox = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var _ref$label = _ref.label,
    label = _ref$label === void 0 ? "" : _ref$label,
    _ref$error = _ref.error,
    error = _ref$error === void 0 ? "" : _ref$error,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? "" : _ref$className,
    _ref$required = _ref.required,
    required = _ref$required === void 0 ? false : _ref$required,
    labelProps = _ref.labelProps,
    children = _ref.children,
    otherProps = _objectWithoutProperties(_ref, _excluded);
  var id = useId.useId(otherProps.id);
  var errorId = "error_".concat(id);
  var renderLabel = label || children;
  return /*#__PURE__*/React.createElement("div", {
    className: classnames(["neeto-ui-checkbox__wrapper", className])
  }, /*#__PURE__*/React.createElement("div", {
    className: "neeto-ui-checkbox__container"
  }, /*#__PURE__*/React.createElement("input", _extends({
    id: id,
    ref: ref,
    required: required,
    "aria-invalid": !!error,
    className: "neeto-ui-checkbox",
    "data-cy": "".concat(index.hyphenize(renderLabel), "-checkbox-input"),
    name: id,
    type: "checkbox"
  }, otherProps)), renderLabel && /*#__PURE__*/React.createElement(Label, _extends({
    required: required,
    "data-cy": "".concat(index.hyphenize(renderLabel), "-checkbox-label"),
    htmlFor: id
  }, labelProps), renderLabel)), !!error && /*#__PURE__*/React.createElement("p", {
    className: "neeto-ui-input__error",
    "data-cy": "".concat(index.hyphenize(renderLabel), "-checkbox-error"),
    id: errorId
  }, error));
});
Checkbox.displayName = "Checkbox";

module.exports = Checkbox;
//# sourceMappingURL=Checkbox.js.map
