'use strict';

var _extends = require('@babel/runtime/helpers/extends');
var _objectWithoutProperties = require('@babel/runtime/helpers/objectWithoutProperties');
var React = require('react');
var classnames = require('classnames');
var Typography = require('./Typography.js');
var Tooltip = require('./Tooltip.js');
require('@babel/runtime/helpers/defineProperty');
require('@babel/runtime/helpers/slicedToArray');
require('@tippyjs/react');
require('tippy.js');

var Title = function Title(_ref) {
  var className = _ref.className,
    children = _ref.children;
  return /*#__PURE__*/React.createElement(Typography, {
    className: classnames("neeto-ui-mb-1", className),
    "data-testid": "popover-title",
    lineHeight: "snug",
    style: "h5",
    weight: "semibold"
  }, children);
};

var _excluded = ["children", "className", "theme"];
var Popover = function Popover(_ref) {
  var children = _ref.children,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? "" : _ref$className,
    _ref$theme = _ref.theme,
    theme = _ref$theme === void 0 ? "light" : _ref$theme,
    otherProps = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/React.createElement(Tooltip, _extends({
    theme: theme,
    arrow: true,
    interactive: true,
    className: classnames("neeto-ui-popover", className),
    content: children
  }, otherProps));
};
Popover.Title = Title;

module.exports = Popover;
//# sourceMappingURL=Popover.js.map
