'use strict';

var React = require('react');
var classnames = require('classnames');
var framerMotion = require('framer-motion');

var ProgressBar = function ProgressBar(_ref) {
  var progressPercentage = _ref.progressPercentage,
    progressValue = _ref.progressValue,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? "" : _ref$className;
  return /*#__PURE__*/React.createElement("div", {
    className: classnames(["neeto-ui-progress-bar__wrapper neeto-ui-rounded-full", className])
  }, /*#__PURE__*/React.createElement(framerMotion.motion.div, {
    animate: {
      width: "".concat(progressPercentage, "%")
    },
    className: "neeto-ui-progress-bar neeto-ui-rounded-full",
    "data-cy": "progress-bar",
    initial: {
      width: 0
    },
    transition: {
      duration: 0.5,
      ease: "easeInOut"
    }
  }, progressValue !== null && progressValue !== void 0 ? progressValue : "".concat(progressPercentage, "%")));
};

module.exports = ProgressBar;
//# sourceMappingURL=ProgressBar.js.map
