'use strict';

var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _extends = require('@babel/runtime/helpers/extends');
var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var _objectWithoutProperties = require('@babel/runtime/helpers/objectWithoutProperties');
var React = require('react');
var classnames = require('classnames');
var Label = require('./Label.js');
var useId = require('./useId-DXHUzdxd.js');
require('react-router-dom');
require('@bigbinary/neeto-hotkeys');
require('./overlayManager.js');
var index = require('./index-Ci1VcKxO.js');
require('qs');
require('@bigbinary/neeto-icons');
require('./Button.js');
require('./Spinner.js');
require('./Tooltip.js');
require('@tippyjs/react');
require('tippy.js');
require('./Popover.js');
require('./Typography.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('@bigbinary/neeto-cist');
require('ramda');
require('./en-CPeHe9Ab.js');
require('@babel/runtime/helpers/toConsumableArray');
require('dayjs');
require('dayjs/plugin/localeData');
require('dayjs/plugin/utc');
require('dayjs/plugin/weekday');
require('dayjs/plugin/weekOfYear');

var _excluded$1 = ["name", "label", "className", "labelProps", "dataCy"];
var Item = function Item(_ref) {
  var _ref$name = _ref.name,
    name = _ref$name === void 0 ? "" : _ref$name,
    _ref$label = _ref.label,
    label = _ref$label === void 0 ? "" : _ref$label,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? "" : _ref$className,
    labelProps = _ref.labelProps,
    _ref$dataCy = _ref.dataCy,
    dataCy = _ref$dataCy === void 0 ? "" : _ref$dataCy,
    otherProps = _objectWithoutProperties(_ref, _excluded$1);
  var id = useId.useId(otherProps.id);
  return /*#__PURE__*/React.createElement("div", {
    className: classnames(["neeto-ui-radio__item", className])
  }, /*#__PURE__*/React.createElement("input", _extends({
    id: id,
    name: name,
    className: "neeto-ui-radio",
    "data-cy": dataCy || "".concat(index.hyphenize(label), "-radio-input"),
    type: "radio"
  }, otherProps)), label && /*#__PURE__*/React.createElement(Label, _extends({
    "data-cy": dataCy || "".concat(index.hyphenize(label), "-radio-label"),
    htmlFor: id
  }, labelProps), label));
};
Item.displayName = "Radio.Item";

var _excluded = ["label", "children", "stacked", "className", "containerClassName", "error", "onChange", "labelProps"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var Radio = function Radio(_ref) {
  var _ref$label = _ref.label,
    label = _ref$label === void 0 ? "" : _ref$label,
    children = _ref.children,
    _ref$stacked = _ref.stacked,
    stacked = _ref$stacked === void 0 ? false : _ref$stacked,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? "" : _ref$className,
    _ref$containerClassNa = _ref.containerClassName,
    containerClassName = _ref$containerClassNa === void 0 ? "" : _ref$containerClassNa,
    _ref$error = _ref.error,
    error = _ref$error === void 0 ? "" : _ref$error,
    onChange = _ref.onChange,
    labelProps = _ref.labelProps,
    props = _objectWithoutProperties(_ref, _excluded);
  var _useState = React.useState(""),
    _useState2 = _slicedToArray(_useState, 2),
    internalValue = _useState2[0],
    setInternalValue = _useState2[1];
  var id = useId.useId(props.id);
  var errorId = "error_".concat(id);
  var internalOnChange = function internalOnChange(e) {
    return setInternalValue(e.target.value);
  };
  return /*#__PURE__*/React.createElement("div", {
    className: classnames(["neeto-ui-radio__wrapper", className])
  }, label && /*#__PURE__*/React.createElement(Label, _extends({
    className: "neeto-ui-radio__label"
  }, labelProps), label), /*#__PURE__*/React.createElement("div", {
    className: classnames(["neeto-ui-radio__container"], _defineProperty({
      "neeto-ui-radio__container--stacked": stacked,
      "neeto-ui-radio__container--error": error
    }, containerClassName, containerClassName))
  }, React.Children.map(children, function (child) {
    var _child$props$checked, _ref2, _child$props$onChange;
    return /*#__PURE__*/React.cloneElement(child, _objectSpread(_objectSpread(_objectSpread({}, child.props), props), {}, {
      value: child.props.value,
      checked: (_child$props$checked = child.props.checked) !== null && _child$props$checked !== void 0 ? _child$props$checked : [internalValue, props.value].includes(child.props.value),
      onChange: (_ref2 = (_child$props$onChange = child.props.onChange) !== null && _child$props$onChange !== void 0 ? _child$props$onChange : onChange) !== null && _ref2 !== void 0 ? _ref2 : internalOnChange
    }));
  })), !!error && /*#__PURE__*/React.createElement("p", {
    className: "neeto-ui-radio-input__error",
    "data-cy": "".concat(index.hyphenize(label), "-radio-input-error"),
    id: errorId
  }, error));
};
Radio.Item = Item;

module.exports = Radio;
//# sourceMappingURL=Radio.js.map
