'use strict';

var _extends$1 = require('@babel/runtime/helpers/extends');
var _defineProperty$1 = require('@babel/runtime/helpers/defineProperty');
var _objectWithoutProperties$1 = require('@babel/runtime/helpers/objectWithoutProperties');
var React = require('react');
var classnames = require('classnames');
var neetoCist = require('@bigbinary/neeto-cist');
var neetoIcons = require('@bigbinary/neeto-icons');
var ramda = require('ramda');
var reactSelectCreatable_esm = require('./react-select-creatable.esm-Bdv9YAMt.js');
var _extends = require('@babel/runtime/helpers/esm/extends');
require('@babel/runtime/helpers/objectSpread2');
require('@babel/runtime/helpers/slicedToArray');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('@babel/runtime/helpers/inherits');
require('@babel/runtime/helpers/createSuper');
require('@babel/runtime/helpers/toConsumableArray');
require('@babel/runtime/helpers/taggedTemplateLiteral');
require('@babel/runtime/helpers/typeof');
require('react-dom');
var _defineProperty = require('@babel/runtime/helpers/esm/defineProperty');
var _objectSpread$1 = require('@babel/runtime/helpers/esm/objectSpread2');
var _slicedToArray = require('@babel/runtime/helpers/esm/slicedToArray');
var _objectWithoutProperties = require('@babel/runtime/helpers/esm/objectWithoutProperties');
var useId = require('./useId-DXHUzdxd.js');
require('react-router-dom');
require('@bigbinary/neeto-hotkeys');
require('./overlayManager.js');
var index = require('./index-Ci1VcKxO.js');
require('qs');
var Label = require('./Label.js');
var Spinner = require('./Spinner.js');
require('@babel/runtime/helpers/esm/classCallCheck');
require('@babel/runtime/helpers/esm/createClass');
require('@babel/runtime/helpers/esm/inherits');
require('@babel/runtime/helpers/esm/createSuper');
require('@babel/runtime/helpers/esm/toConsumableArray');
require('@babel/runtime/helpers/esm/taggedTemplateLiteral');
require('@babel/runtime/helpers/esm/typeof');
require('./en-CPeHe9Ab.js');
require('dayjs');
require('dayjs/plugin/localeData');
require('dayjs/plugin/utc');
require('dayjs/plugin/weekday');
require('dayjs/plugin/weekOfYear');
require('./Button.js');
require('./Tooltip.js');
require('@tippyjs/react');
require('tippy.js');
require('./Popover.js');
require('./Typography.js');

function _interopNamespaceDefault(e) {
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () { return e[k]; }
        });
      }
    });
  }
  n.default = e;
  return Object.freeze(n);
}

var React__namespace = /*#__PURE__*/_interopNamespaceDefault(React);

var StateManagedSelect = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var baseSelectProps = reactSelectCreatable_esm.useStateManager(props);
  return /*#__PURE__*/React__namespace.createElement(reactSelectCreatable_esm.Select, _extends({
    ref: ref
  }, baseSelectProps));
});

var _excluded$1 = ["defaultOptions", "cacheOptions", "loadOptions", "options", "isLoading", "onInputChange", "filterOption"];
function useAsync(_ref) {
  var _ref$defaultOptions = _ref.defaultOptions,
    propsDefaultOptions = _ref$defaultOptions === void 0 ? false : _ref$defaultOptions,
    _ref$cacheOptions = _ref.cacheOptions,
    cacheOptions = _ref$cacheOptions === void 0 ? false : _ref$cacheOptions,
    propsLoadOptions = _ref.loadOptions;
    _ref.options;
    var _ref$isLoading = _ref.isLoading,
    propsIsLoading = _ref$isLoading === void 0 ? false : _ref$isLoading,
    propsOnInputChange = _ref.onInputChange,
    _ref$filterOption = _ref.filterOption,
    filterOption = _ref$filterOption === void 0 ? null : _ref$filterOption,
    restSelectProps = _objectWithoutProperties(_ref, _excluded$1);
  var propsInputValue = restSelectProps.inputValue;
  var lastRequest = React.useRef(undefined);
  var mounted = React.useRef(false);
  var _useState = React.useState(Array.isArray(propsDefaultOptions) ? propsDefaultOptions : undefined),
    _useState2 = _slicedToArray(_useState, 2),
    defaultOptions = _useState2[0],
    setDefaultOptions = _useState2[1];
  var _useState3 = React.useState(typeof propsInputValue !== 'undefined' ? propsInputValue : ''),
    _useState4 = _slicedToArray(_useState3, 2),
    stateInputValue = _useState4[0],
    setStateInputValue = _useState4[1];
  var _useState5 = React.useState(propsDefaultOptions === true),
    _useState6 = _slicedToArray(_useState5, 2),
    isLoading = _useState6[0],
    setIsLoading = _useState6[1];
  var _useState7 = React.useState(undefined),
    _useState8 = _slicedToArray(_useState7, 2),
    loadedInputValue = _useState8[0],
    setLoadedInputValue = _useState8[1];
  var _useState9 = React.useState([]),
    _useState10 = _slicedToArray(_useState9, 2),
    loadedOptions = _useState10[0],
    setLoadedOptions = _useState10[1];
  var _useState11 = React.useState(false),
    _useState12 = _slicedToArray(_useState11, 2),
    passEmptyOptions = _useState12[0],
    setPassEmptyOptions = _useState12[1];
  var _useState13 = React.useState({}),
    _useState14 = _slicedToArray(_useState13, 2),
    optionsCache = _useState14[0],
    setOptionsCache = _useState14[1];
  var _useState15 = React.useState(undefined),
    _useState16 = _slicedToArray(_useState15, 2),
    prevDefaultOptions = _useState16[0],
    setPrevDefaultOptions = _useState16[1];
  var _useState17 = React.useState(undefined),
    _useState18 = _slicedToArray(_useState17, 2),
    prevCacheOptions = _useState18[0],
    setPrevCacheOptions = _useState18[1];
  if (cacheOptions !== prevCacheOptions) {
    setOptionsCache({});
    setPrevCacheOptions(cacheOptions);
  }
  if (propsDefaultOptions !== prevDefaultOptions) {
    setDefaultOptions(Array.isArray(propsDefaultOptions) ? propsDefaultOptions : undefined);
    setPrevDefaultOptions(propsDefaultOptions);
  }
  React.useEffect(function () {
    mounted.current = true;
    return function () {
      mounted.current = false;
    };
  }, []);
  var loadOptions = React.useCallback(function (inputValue, callback) {
    if (!propsLoadOptions) return callback();
    var loader = propsLoadOptions(inputValue, callback);
    if (loader && typeof loader.then === 'function') {
      loader.then(callback, function () {
        return callback();
      });
    }
  }, [propsLoadOptions]);
  React.useEffect(function () {
    if (propsDefaultOptions === true) {
      loadOptions(stateInputValue, function (options) {
        if (!mounted.current) return;
        setDefaultOptions(options || []);
        setIsLoading(!!lastRequest.current);
      });
    }
    // NOTE: this effect is designed to only run when the component mounts,
    // so we don't want to include any hook dependencies
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  var onInputChange = React.useCallback(function (newValue, actionMeta) {
    var inputValue = reactSelectCreatable_esm.handleInputChange(newValue, actionMeta, propsOnInputChange);
    if (!inputValue) {
      lastRequest.current = undefined;
      setStateInputValue('');
      setLoadedInputValue('');
      setLoadedOptions([]);
      setIsLoading(false);
      setPassEmptyOptions(false);
      return;
    }
    if (cacheOptions && optionsCache[inputValue]) {
      setStateInputValue(inputValue);
      setLoadedInputValue(inputValue);
      setLoadedOptions(optionsCache[inputValue]);
      setIsLoading(false);
      setPassEmptyOptions(false);
    } else {
      var request = lastRequest.current = {};
      setStateInputValue(inputValue);
      setIsLoading(true);
      setPassEmptyOptions(!loadedInputValue);
      loadOptions(inputValue, function (options) {
        if (!mounted) return;
        if (request !== lastRequest.current) return;
        lastRequest.current = undefined;
        setIsLoading(false);
        setLoadedInputValue(inputValue);
        setLoadedOptions(options || []);
        setPassEmptyOptions(false);
        setOptionsCache(options ? _objectSpread$1(_objectSpread$1({}, optionsCache), {}, _defineProperty({}, inputValue, options)) : optionsCache);
      });
    }
  }, [cacheOptions, loadOptions, loadedInputValue, optionsCache, propsOnInputChange]);
  var options = passEmptyOptions ? [] : stateInputValue && loadedInputValue ? loadedOptions : defaultOptions || [];
  return _objectSpread$1(_objectSpread$1({}, restSelectProps), {}, {
    options: options,
    isLoading: isLoading || propsIsLoading,
    onInputChange: onInputChange,
    filterOption: filterOption
  });
}

var AsyncSelect = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var stateManagedProps = useAsync(props);
  var selectProps = reactSelectCreatable_esm.useStateManager(stateManagedProps);
  return /*#__PURE__*/React__namespace.createElement(reactSelectCreatable_esm.Select, _extends({
    ref: ref
  }, selectProps));
});

var AsyncCreatableSelect = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var stateManagerProps = useAsync(props);
  var creatableProps = reactSelectCreatable_esm.useStateManager(stateManagerProps);
  var selectProps = reactSelectCreatable_esm.useCreatable(creatableProps);
  return /*#__PURE__*/React__namespace.createElement(reactSelectCreatable_esm.Select, _extends({
    ref: ref
  }, selectProps));
});

var _excluded = ["children"],
  _excluded2 = ["size", "label", "required", "error", "helpText", "className", "innerRef", "isCreateable", "strategy", "id", "labelProps", "value", "defaultValue", "components", "optionRemapping", "onMenuClose", "onMenuOpen", "onKeyDown", "styles"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty$1(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var SIZES = {
  small: "small",
  medium: "medium",
  large: "large"
};
var STRATEGIES = {
  "default": "default",
  fixed: "fixed"
};
var Control = function Control(_ref) {
  var children = _ref.children,
    props = _objectWithoutProperties$1(_ref, _excluded);
  var selectProps = props.selectProps,
    hasValue = props.hasValue;
  return /*#__PURE__*/React.createElement(reactSelectCreatable_esm.components.Control, props, hasValue && selectProps.isMulti && /*#__PURE__*/React.createElement("span", {
    className: "neeto-ui-btn neeto-ui-btn--style-secondary neeto-ui-react-select__add-btn"
  }, selectProps.addButtonLabel || "Add"), " ", children);
};
var DropdownIndicator = function DropdownIndicator(props) {
  return /*#__PURE__*/React.createElement(reactSelectCreatable_esm.components.DropdownIndicator, _extends$1({}, props, {
    innerProps: _objectSpread(_objectSpread({}, props.innerProps), {}, _defineProperty$1({}, "data-cy", "action-select-indicator"))
  }), /*#__PURE__*/React.createElement(neetoIcons.Down, {
    size: 16
  }));
};
var ClearIndicator = function ClearIndicator(props) {
  return /*#__PURE__*/React.createElement(reactSelectCreatable_esm.components.ClearIndicator, _extends$1({}, props, {
    innerProps: _objectSpread(_objectSpread({}, props.innerProps), {}, {
      "data-cy": "clear-select-indicator"
    })
  }), /*#__PURE__*/React.createElement(neetoIcons.Close, {
    size: 16
  }));
};
var MultiValueRemove = function MultiValueRemove(props) {
  return /*#__PURE__*/React.createElement(reactSelectCreatable_esm.components.MultiValueRemove, props, /*#__PURE__*/React.createElement(neetoIcons.Close, {
    size: 16
  }));
};
var CustomInput = function CustomInput(props) {
  var selectProps = props.selectProps;
  return /*#__PURE__*/React.createElement(reactSelectCreatable_esm.components.Input, _extends$1({}, props, {
    "data-cy": selectProps ? selectProps["data-cy"] : "select-input",
    "data-testid": selectProps && selectProps["data-testid"],
    maxLength: selectProps && selectProps.maxLength
  }));
};
var CustomOption = function CustomOption(props) {
  var ref = React.useRef();
  var dataCy = props.data.dataCy;
  React.useEffect(function () {
    props.isSelected && ref.current.scrollIntoView();
  }, [props.isSelected]);
  return /*#__PURE__*/React.createElement(reactSelectCreatable_esm.components.Option, _extends$1({}, props, {
    innerRef: ref,
    innerProps: _objectSpread(_objectSpread({}, props.innerProps), {}, {
      "data-cy": dataCy || "".concat(index.hyphenize(props.label), "-select-option")
    })
  }));
};
var Placeholder = function Placeholder(props) {
  var selectProps = props.selectProps;
  return /*#__PURE__*/React.createElement(reactSelectCreatable_esm.components.Placeholder, _extends$1({}, props, {
    innerProps: _objectSpread(_objectSpread({}, props.innerProps), {}, {
      "data-cy": selectProps ? "".concat(index.hyphenize(selectProps.label), "-select-placeholder") : "select-placeholder"
    })
  }));
};
var Menu = function Menu(props) {
  var selectProps = props.selectProps;
  return /*#__PURE__*/React.createElement(reactSelectCreatable_esm.components.Menu, _extends$1({}, props, {
    innerProps: _objectSpread(_objectSpread({}, props.innerProps), {}, {
      "data-cy": selectProps ? "".concat(index.hyphenize(selectProps.label), "-select-menu") : "select-menu"
    })
  }));
};
var SingleValue = function SingleValue(props) {
  return /*#__PURE__*/React.createElement(reactSelectCreatable_esm.components.SingleValue, _extends$1({}, props, {
    innerProps: _objectSpread(_objectSpread({}, props.innerProps), {}, {
      "data-cy": "select-single-value"
    })
  }));
};
var ValueContainer = function ValueContainer(props) {
  var selectProps = props.selectProps;
  return /*#__PURE__*/React.createElement(reactSelectCreatable_esm.components.ValueContainer, _extends$1({}, props, {
    innerProps: _objectSpread(_objectSpread({}, props.innerProps), {}, {
      name: selectProps.name,
      "data-cy": selectProps ? "".concat(index.hyphenize(selectProps.label), "-select-value-container") : "select-value-container"
    })
  }));
};
var MenuList = function MenuList(props) {
  var _props$selectProps = props.selectProps,
    fetchMore = _props$selectProps.fetchMore,
    totalOptionsCount = _props$selectProps.totalOptionsCount,
    isAsyncLoadOptionEnabled = _props$selectProps.isAsyncLoadOptionEnabled,
    options = _props$selectProps.options,
    _props$selectProps$po = _props$selectProps.portalProps,
    portalProps = _props$selectProps$po === void 0 ? {} : _props$selectProps$po;
  var hasMore = isAsyncLoadOptionEnabled && totalOptionsCount > options.length;
  var loaderRef = React.useRef();
  React.useEffect(function () {
    var observer = null;
    if (loaderRef.current && isAsyncLoadOptionEnabled) {
      observer = new IntersectionObserver(function (entries) {
        return entries[0].isIntersecting && fetchMore();
      }, {
        root: null,
        rootMargin: "0px",
        threshold: 0.1
      });
      observer.observe(loaderRef.current);
    }
    return function () {
      var _observer;
      if (!(loaderRef.current && isAsyncLoadOptionEnabled)) return;
      (_observer = observer) === null || _observer === void 0 || _observer.unobserve(loaderRef.current);
    };
  }, [hasMore]);
  return /*#__PURE__*/React.createElement(reactSelectCreatable_esm.components.MenuList, _extends$1({}, props, portalProps, {
    innerProps: _objectSpread(_objectSpread({}, props.innerProps), {}, _defineProperty$1({}, "data-testid", "menu-list"))
  }), props.children, hasMore && /*#__PURE__*/React.createElement("div", {
    className: "neeto-ui-flex neeto-ui-w-full neeto-ui-items-center neeto-ui-justify-center neeto-ui-py-3",
    "data-testid": "loader",
    ref: loaderRef
  }, /*#__PURE__*/React.createElement(Spinner, null)));
};
var Select = function Select(_ref2) {
  var _ref3, _otherProps$isMenuOpe;
  var _ref2$size = _ref2.size,
    size = _ref2$size === void 0 ? SIZES.medium : _ref2$size,
    _ref2$label = _ref2.label,
    label = _ref2$label === void 0 ? "" : _ref2$label,
    _ref2$required = _ref2.required,
    required = _ref2$required === void 0 ? false : _ref2$required,
    _ref2$error = _ref2.error,
    error = _ref2$error === void 0 ? "" : _ref2$error,
    _ref2$helpText = _ref2.helpText,
    helpText = _ref2$helpText === void 0 ? "" : _ref2$helpText,
    _ref2$className = _ref2.className,
    className = _ref2$className === void 0 ? "" : _ref2$className,
    innerRef = _ref2.innerRef,
    _ref2$isCreateable = _ref2.isCreateable,
    isCreateable = _ref2$isCreateable === void 0 ? false : _ref2$isCreateable,
    _ref2$strategy = _ref2.strategy,
    strategy = _ref2$strategy === void 0 ? STRATEGIES["default"] : _ref2$strategy,
    id = _ref2.id,
    labelProps = _ref2.labelProps,
    value = _ref2.value,
    defaultValue = _ref2.defaultValue,
    componentOverrides = _ref2.components,
    _ref2$optionRemapping = _ref2.optionRemapping,
    optionRemapping = _ref2$optionRemapping === void 0 ? {} : _ref2$optionRemapping,
    onMenuClose = _ref2.onMenuClose,
    onMenuOpen = _ref2.onMenuOpen,
    onKeyDown = _ref2.onKeyDown,
    _ref2$styles = _ref2.styles,
    styles = _ref2$styles === void 0 ? {} : _ref2$styles,
    otherProps = _objectWithoutProperties$1(_ref2, _excluded2);
  var inputId = useId.useId(id);
  var isMenuOpen = React.useRef((_ref3 = (_otherProps$isMenuOpe = otherProps.isMenuOpen) !== null && _otherProps$isMenuOpe !== void 0 ? _otherProps$isMenuOpe : otherProps.defaultMenuIsOpen) !== null && _ref3 !== void 0 ? _ref3 : false);
  var Parent = StateManagedSelect;
  if (isCreateable) {
    Parent = reactSelectCreatable_esm.CreatableSelect;
  }
  if (otherProps.loadOptions) {
    Parent = isCreateable ? AsyncCreatableSelect : AsyncSelect;
  }
  if (optionRemapping.value) {
    otherProps.getOptionValue = ramda.prop(optionRemapping.value);
  }
  if (optionRemapping.label) {
    otherProps.getOptionLabel = ramda.prop(optionRemapping.label);
  }
  var portalProps = strategy === STRATEGIES.fixed && {
    menuPortalTarget: document.body,
    styles: ramda.mergeDeepRight({
      menuPortal: ramda.assoc("zIndex", 999999)
    }, styles),
    menuPosition: "fixed"
  };
  var options = otherProps.options,
    defaultOptions = otherProps.defaultOptions,
    getOptionValue = otherProps.getOptionValue;
  var getRealOptionValue = function getRealOptionValue(option) {
    if (typeof getOptionValue !== "function") {
      return option.value;
    }
    return getOptionValue(option);
  };
  var findInOptions = function findInOptions(value) {
    var _currentOptions;
    var fetchMore = otherProps.fetchMore,
      isMulti = otherProps.isMulti;
    if (!value || isMulti || neetoCist.isPresent(fetchMore)) {
      return value;
    }
    var currentOptions = options || defaultOptions;
    if (Array.isArray(value)) value = value[0];
    var isGrouped = neetoCist._existsBy({
      options: Array.isArray
    }, currentOptions);
    if (isGrouped) {
      currentOptions = ramda.flatten(ramda.pluck("options", currentOptions));
    }
    return (_currentOptions = currentOptions) === null || _currentOptions === void 0 ? void 0 : _currentOptions.filter(function (opt) {
      return getRealOptionValue(opt) === getRealOptionValue(value);
    });
  };
  var handleMenuOpen = function handleMenuOpen() {
    isMenuOpen.current = true;
    onMenuOpen === null || onMenuOpen === void 0 || onMenuOpen();
  };
  var handleMenuClose = function handleMenuClose() {
    isMenuOpen.current = false;
    onMenuClose === null || onMenuClose === void 0 || onMenuClose();
  };
  var handleKeyDown = function handleKeyDown(e) {
    if (!isMenuOpen.current) return;
    e.stopPropagation();
    onKeyDown === null || onKeyDown === void 0 || onKeyDown(e);
  };
  return /*#__PURE__*/React.createElement("div", {
    className: classnames(["neeto-ui-input__wrapper", className]),
    "data-cy": "".concat(index.hyphenize(label), "-select-container-wrapper"),
    "data-testid": "select"
  }, label && /*#__PURE__*/React.createElement(Label, _extends$1({
    required: required,
    "data-cy": "".concat(index.hyphenize(label), "-input-label"),
    "data-testid": "select-label",
    htmlFor: inputId
  }, labelProps), label), /*#__PURE__*/React.createElement(Parent, _extends$1({
    blurInputOnSelect: false,
    classNamePrefix: "neeto-ui-react-select",
    closeMenuOnSelect: !otherProps.isMulti,
    "data-cy": "".concat(index.hyphenize(label), "-select-container"),
    defaultValue: findInOptions(defaultValue),
    ref: innerRef,
    value: findInOptions(value),
    className: classnames(["neeto-ui-react-select__container"], {
      "neeto-ui-react-select__container--error": !!error,
      "neeto-ui-react-select__container--small": size === SIZES.small,
      "neeto-ui-react-select__container--medium": size === SIZES.medium,
      "neeto-ui-react-select__container--large": size === SIZES.large
    }),
    components: _objectSpread({
      Input: CustomInput,
      Option: CustomOption,
      DropdownIndicator: DropdownIndicator,
      ClearIndicator: ClearIndicator,
      MultiValueRemove: MultiValueRemove,
      Placeholder: Placeholder,
      Menu: Menu,
      ValueContainer: ValueContainer,
      MenuList: MenuList,
      SingleValue: SingleValue,
      Control: Control
    }, componentOverrides),
    onKeyDown: handleKeyDown,
    onMenuClose: handleMenuClose,
    onMenuOpen: handleMenuOpen
  }, _objectSpread(_objectSpread({
    inputId: inputId,
    label: label,
    styles: styles
  }, portalProps), otherProps))), !!error && /*#__PURE__*/React.createElement("p", {
    className: "neeto-ui-input__error",
    "data-cy": "".concat(index.hyphenize(label), "-select-error"),
    "data-testid": "select-error"
  }, error), helpText && /*#__PURE__*/React.createElement("p", {
    className: "neeto-ui-input__help-text",
    "data-cy": "".concat(index.hyphenize(label), "-select-help-text"),
    "data-testid": "select-help-text"
  }, helpText));
};

module.exports = Select;
//# sourceMappingURL=Select.js.map
