'use strict';

var _ConfigProvider = require('antd/lib/config-provider');
var _Slider = require('antd/lib/slider');
var _extends = require('@babel/runtime/helpers/extends');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _objectWithoutProperties = require('@babel/runtime/helpers/objectWithoutProperties');
var React = require('react');
var reactI18next = require('react-i18next');
var constants = require('./constants.js');
var Label = require('./Label.js');
var useId = require('./useId-DXHUzdxd.js');
require('@babel/runtime/helpers/slicedToArray');
require('react-router-dom');
require('@bigbinary/neeto-hotkeys');
require('./overlayManager.js');
var index = require('./index-Ci1VcKxO.js');
require('qs');
require('antd/locale/de_DE');
require('antd/locale/en_US');
require('antd/locale/es_ES');
require('antd/locale/fr_FR');
require('antd/locale/nl_NL');
require('antd/locale/pl_PL');
require('antd/locale/pt_PT');
require('classnames');
require('@bigbinary/neeto-icons');
require('./Button.js');
require('./Spinner.js');
require('./Tooltip.js');
require('@tippyjs/react');
require('tippy.js');
require('./Popover.js');
require('./Typography.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('@bigbinary/neeto-cist');
require('ramda');
require('./en-CPeHe9Ab.js');
require('@babel/runtime/helpers/toConsumableArray');
require('dayjs');
require('dayjs/plugin/localeData');
require('dayjs/plugin/utc');
require('dayjs/plugin/weekday');
require('dayjs/plugin/weekOfYear');

var _excluded = ["min", "max", "defaultValue", "onChange", "value", "label", "required", "labelProps", "error", "helpText"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var Slider = function Slider(_ref) {
  var _ref$min = _ref.min,
    min = _ref$min === void 0 ? 0 : _ref$min,
    _ref$max = _ref.max,
    max = _ref$max === void 0 ? 100 : _ref$max,
    _ref$defaultValue = _ref.defaultValue,
    defaultValue = _ref$defaultValue === void 0 ? 0 : _ref$defaultValue,
    _ref$onChange = _ref.onChange,
    onChange = _ref$onChange === void 0 ? index.noop : _ref$onChange,
    _ref$value = _ref.value,
    value = _ref$value === void 0 ? undefined : _ref$value,
    label = _ref.label,
    _ref$required = _ref.required,
    required = _ref$required === void 0 ? false : _ref$required,
    _ref$labelProps = _ref.labelProps,
    labelProps = _ref$labelProps === void 0 ? {} : _ref$labelProps,
    error = _ref.error,
    helpText = _ref.helpText,
    otherProps = _objectWithoutProperties(_ref, _excluded);
  var id = useId.useId(otherProps.id);
  var errorId = "error_".concat(id);
  var helpTextId = "helpText_".concat(id);
  var _useTranslation = reactI18next.useTranslation(),
    i18n = _useTranslation.i18n;
  return /*#__PURE__*/React.createElement(_ConfigProvider, {
    locale: constants.ANTD_LOCALE[i18n.language || "en"],
    theme: {
      token: _objectSpread({}, index.ANT_DESIGN_GLOBAL_TOKEN_OVERRIDES),
      components: {
        Slider: {
          dotActiveBorderColor: "rgb(var(--neeto-ui-primary-500))",
          dotBorderColor: "rgb(var(--neeto-ui-gray-500))",
          handleActiveColor: "rgb(var(--neeto-ui-primary-600))",
          handleColor: "rgb(var(--neeto-ui-primary-500))",
          railBg: "rgb(var(--neeto-ui-gray-200))",
          railHoverBg: "rgb(var(--neeto-ui-gray-300))",
          trackBg: "rgb(var(--neeto-ui-primary-500))",
          trackBgDisabled: "rgb(var(--neeto-ui-gray-100))",
          trackHoverBg: "rgb(var(--neeto-ui-primary-600))",
          // Global overrides
          colorFillContentHover: "rgb(var(--neeto-ui-gray-600))"
        }
      }
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "neeto-ui-input__wrapper"
  }, /*#__PURE__*/React.createElement("div", {
    className: "neeto-ui-input__label-wrapper"
  }, label && /*#__PURE__*/React.createElement(Label, _extends({
    required: required,
    "data-cy": "".concat(index.hyphenize(label), "-slider-label"),
    htmlFor: id
  }, labelProps), label)), /*#__PURE__*/React.createElement(_Slider, _extends({
    className: "neeto-ui-w-full",
    tooltip: {
      formatter: null
    }
  }, _objectSpread(_objectSpread({
    defaultValue: defaultValue,
    max: max,
    min: min,
    onChange: onChange,
    value: value
  }, otherProps), {}, {
    id: id
  }))), !!error && /*#__PURE__*/React.createElement("p", {
    className: "neeto-ui-input__error",
    "data-cy": "".concat(index.hyphenize(label), "-input-error"),
    id: errorId
  }, error), helpText && /*#__PURE__*/React.createElement("p", {
    className: "neeto-ui-input__help-text",
    "data-cy": "".concat(index.hyphenize(label), "-input-help"),
    id: helpTextId
  }, helpText)));
};

module.exports = Slider;
//# sourceMappingURL=Slider.js.map
