'use strict';

var React = require('react');
var classnames = require('classnames');

var SPINNER_SIZES = {
  small: "small",
  medium: "medium"
};
var Spinner = function Spinner(_ref) {
  var _ref$theme = _ref.theme,
    theme = _ref$theme === void 0 ? "dark" : _ref$theme,
    _ref$size = _ref.size,
    size = _ref$size === void 0 ? SPINNER_SIZES.medium : _ref$size,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? "" : _ref$className;
  return /*#__PURE__*/React.createElement("span", {
    "data-cy": "neeto-ui-spinner",
    "data-testid": "spinner",
    className: classnames("neeto-ui-spinner", {
      "neeto-ui-spinner--dark": theme === "dark",
      "neeto-ui-spinner--light": theme === "light",
      "neeto-ui-spinner--size-small": size === SPINNER_SIZES.small,
      "neeto-ui-spinner--size-medium": size === SPINNER_SIZES.medium
    }, [className])
  });
};

module.exports = Spinner;
//# sourceMappingURL=Spinner.js.map
