'use strict';

var _extends = require('@babel/runtime/helpers/extends');
var _objectWithoutProperties = require('@babel/runtime/helpers/objectWithoutProperties');
var React = require('react');
var classnames = require('classnames');
var neetoIcons = require('@bigbinary/neeto-icons');
var useId = require('./useId-DXHUzdxd.js');
require('@babel/runtime/helpers/slicedToArray');
require('react-router-dom');
require('@bigbinary/neeto-hotkeys');
require('./overlayManager.js');
var index = require('./index-Ci1VcKxO.js');
require('@babel/runtime/helpers/defineProperty');
require('qs');
var Label = require('./Label.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('@bigbinary/neeto-cist');
require('ramda');
require('./en-CPeHe9Ab.js');
require('@babel/runtime/helpers/toConsumableArray');
require('dayjs');
require('dayjs/plugin/localeData');
require('dayjs/plugin/utc');
require('dayjs/plugin/weekday');
require('dayjs/plugin/weekOfYear');
require('./Button.js');
require('./Spinner.js');
require('./Tooltip.js');
require('@tippyjs/react');
require('tippy.js');
require('./Popover.js');
require('./Typography.js');

var _excluded = ["label", "required", "className", "error", "onChange", "labelProps", "children"];
var Switch = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var _ref$label = _ref.label,
    label = _ref$label === void 0 ? "" : _ref$label,
    _ref$required = _ref.required,
    required = _ref$required === void 0 ? false : _ref$required,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? "" : _ref$className,
    _ref$error = _ref.error,
    error = _ref$error === void 0 ? "" : _ref$error,
    _ref$onChange = _ref.onChange,
    onChange = _ref$onChange === void 0 ? index.noop : _ref$onChange,
    labelProps = _ref.labelProps,
    children = _ref.children,
    otherProps = _objectWithoutProperties(_ref, _excluded);
  var id = useId.useId(otherProps.id);
  var errorId = "error_".concat(id);
  var checked = otherProps.checked,
    disabled = otherProps.disabled;
  var renderLabel = label || children;
  return /*#__PURE__*/React.createElement("div", {
    ref: ref,
    className: classnames(["neeto-ui-switch__wrapper", className])
  }, /*#__PURE__*/React.createElement("div", {
    className: "neeto-ui-switch__container"
  }, /*#__PURE__*/React.createElement("label", {
    tabIndex: 0,
    className: classnames("neeto-ui-switch__item", {
      "neeto-ui-switch__item--checked": !!checked,
      "neeto-ui-switch__item--disabled": disabled
    })
  }, /*#__PURE__*/React.createElement("input", _extends({
    id: id,
    onChange: onChange,
    type: "checkbox"
  }, otherProps)), /*#__PURE__*/React.createElement("span", {
    "aria-hidden": "true",
    "data-cy": "".concat(index.hyphenize(renderLabel), "-switch"),
    className: classnames("neeto-ui-switch", {
      "neeto-ui-switch--checked": !!checked
    })
  }, checked ? /*#__PURE__*/React.createElement(neetoIcons.Check, {
    "data-cy": "check-icon",
    "data-testid": "check-icon",
    size: "12",
    strokeWidth: 4
  }) : /*#__PURE__*/React.createElement(neetoIcons.Close, {
    "data-cy": "close-icon",
    "data-testid": "close-icon",
    size: "12",
    strokeWidth: 3
  }))), renderLabel && /*#__PURE__*/React.createElement(Label, _extends({
    required: required,
    "data-cy": "".concat(index.hyphenize(renderLabel), "-switch-label"),
    htmlFor: id
  }, labelProps), renderLabel)), !!error && /*#__PURE__*/React.createElement("p", {
    className: "neeto-ui-input__error",
    "data-cy": "".concat(index.hyphenize(renderLabel), "-switch-error"),
    id: errorId
  }, error));
});
Switch.displayName = "Switch";

module.exports = Switch;
//# sourceMappingURL=Switch.js.map
