'use strict';

var _extends = require('@babel/runtime/helpers/extends');
var _objectWithoutProperties = require('@babel/runtime/helpers/objectWithoutProperties');
var React = require('react');
var classnames = require('classnames');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var reactRouterDom = require('react-router-dom');

var _excluded$1 = ["active", "className", "children", "icon", "onClick", "activeClassName"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var Item = function Item(_ref) {
  var active = _ref.active,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? "" : _ref$className,
    children = _ref.children,
    _ref$icon = _ref.icon,
    icon = _ref$icon === void 0 ? null : _ref$icon,
    _ref$onClick = _ref.onClick,
    onClick = _ref$onClick === void 0 ? function () {} : _ref$onClick,
    _ref$activeClassName = _ref.activeClassName,
    activeClassName = _ref$activeClassName === void 0 ? "" : _ref$activeClassName,
    otherProps = _objectWithoutProperties(_ref, _excluded$1);
  var Icon = typeof icon === "string" ? function () {
    return /*#__PURE__*/React.createElement("i", {
      className: icon,
      "data-cy": "tab-item-icon",
      "data-testid": "tab-icon"
    });
  } : icon || React.Fragment;
  var Parent = activeClassName ? reactRouterDom.NavLink : "button";
  var buttonAttributes = activeClassName ? {} : {
    type: "button"
  };
  return /*#__PURE__*/React.createElement(Parent, _extends({
    "data-cy": "tab-item",
    className: classnames(["neeto-ui-tab neeto-ui-flex neeto-ui-items-center neeto-ui-justify-center neeto-ui-select-none", className], {
      active: active
    }),
    onClick: onClick
  }, _objectSpread(_objectSpread({}, otherProps), buttonAttributes)), icon && /*#__PURE__*/React.createElement(Icon, {
    className: "neeto-ui-tab__icon"
  }), children);
};
Item.displayName = "Tab.Item";

var _excluded = ["size", "noUnderline", "children", "className"];
var SIZES = {
  large: "large",
  small: "small"
};
var Tab = function Tab(_ref) {
  var _ref$size = _ref.size,
    size = _ref$size === void 0 ? SIZES.small : _ref$size,
    _ref$noUnderline = _ref.noUnderline,
    noUnderline = _ref$noUnderline === void 0 ? false : _ref$noUnderline,
    children = _ref.children,
    _ref$className = _ref.className,
    className = _ref$className === void 0 ? "" : _ref$className,
    otherProps = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/React.createElement("div", _extends({
    "data-cy": "tab-container",
    className: classnames({
      "neeto-ui-tab__wrapper neeto-ui-flex": true,
      "neeto-ui-tab__wrapper--size-large": size === SIZES.large,
      "neeto-ui-tab__wrapper--size-small": size === SIZES.small,
      "neeto-ui-tab__wrapper--underline-none": noUnderline
    }, [className])
  }, otherProps), children);
};
Tab.Item = Item;

module.exports = Tab;
//# sourceMappingURL=Tab.js.map
