'use strict';

var React = require('react');
var reactI18next = require('react-i18next');
var i18n = require('i18next');
var en = require('./en-CPeHe9Ab.js');

var neetoui$5 = {
	blockNavigation: {
		alertMessage: "Alle Ihre nicht gespeicherten Änderungen gehen verloren. Dies kann nicht rückgängig gemacht werden.",
		submitButtonLabel: "Änderungen verwerfen",
		alertTitle: "Du hast nicht gespeicherte Änderungen"
	},
	actionBlock: {
		cancel: "Stornieren",
		saveChanges: "Änderungen speichern"
	},
	colorPicker: {
		recentlyUsed: "Kürzlich verwendet"
	},
	datePicker: {
		today: "Heute"
	},
	table: {
		insertColRight: "Spalte rechts einfügen",
		insertColLeft: "Spalte links einfügen",
		columnInfo: "Spalteninformationen",
		hideColumn: "Spalte ausblenden",
		deleteColumn: "Spalte löschen",
		ascending: "Aufsteigend",
		descending: "Absteigend",
		allRowsSelected: "Alle Zeilen sind ausgewählt",
		clearSelection: "Klare Auswahl"
	},
	timePicker: {
		hours: "Stunden",
		minutes: "Minuten",
		seconds: "Sekunden"
	},
	treeSelect: {
		noOptions: "Keine Optionen"
	}
};
var deTranslations = {
	neetoui: neetoui$5
};

var neetoui$4 = {
	blockNavigation: {
		alertMessage: "Todos los cambios no guardados se perderán. Esto no se puede deshacer.",
		submitButtonLabel: "Descartar los cambios",
		alertTitle: "Tiene cambios sin guardar"
	},
	actionBlock: {
		cancel: "Cancelar",
		saveChanges: "Guardar cambios"
	},
	datePicker: {
		today: "Hoy"
	},
	colorPicker: {
		recentlyUsed: "Usado recientemente"
	},
	table: {
		insertColRight: "Insertar columna a la derecha",
		insertColLeft: "Insertar columna a la izquierda",
		columnInfo: "Información de la columna",
		hideColumn: "Ocultar columna",
		deleteColumn: "Eliminar columna",
		ascending: "Ascendente",
		descending: "Descendente",
		allRowsSelected: "Todas las filas están seleccionadas",
		clearSelection: "Borrar selección"
	},
	timePicker: {
		hours: "Horas",
		minutes: "Minutos",
		seconds: "Segundos"
	},
	treeSelect: {
		noOptions: "Sin opciones"
	}
};
var esTranslations = {
	neetoui: neetoui$4
};

var neetoui$3 = {
	blockNavigation: {
		alertMessage: "Toutes vos modifications non enregistrées seront perdues. Cela ne peut pas être annulé.",
		submitButtonLabel: "Annuler les modifications",
		alertTitle: "Vous avez des changements non enregistrés"
	},
	actionBlock: {
		cancel: "Annuler",
		saveChanges: "Sauvegarder les modifications"
	},
	datePicker: {
		today: "Aujourd'hui"
	},
	colorPicker: {
		recentlyUsed: "Récemment utilisé"
	},
	table: {
		insertColRight: "Insérer une colonne à droite",
		insertColLeft: "Insérer une colonne à gauche",
		columnInfo: "Informations sur la colonne",
		hideColumn: "Masquer la colonne",
		deleteColumn: "Supprimer la colonne",
		ascending: "Ascendant",
		descending: "Descendant",
		allRowsSelected: "Toutes les lignes sont sélectionnées",
		clearSelection: "Effacer la sélection"
	},
	timePicker: {
		hours: "Heures",
		minutes: "Minutes",
		seconds: "Seconds"
	},
	treeSelect: {
		noOptions: "Aucune option"
	}
};
var frTranslations = {
	neetoui: neetoui$3
};

var neetoui$2 = {
	blockNavigation: {
		alertMessage: "Al uw niet-opgeslagen wijzigingen gaan verloren. Dit kan niet ongedaan worden gemaakt.",
		submitButtonLabel: "Veranderingen ongedaan maken",
		alertTitle: "U heeft niet-opgeslagen wijzigingen"
	},
	actionBlock: {
		cancel: "Annuleren",
		saveChanges: "Wijzigingen opslaan"
	},
	colorPicker: {
		recentlyUsed: "Recent gebruikt"
	},
	datePicker: {
		today: "Vandaag"
	},
	table: {
		insertColRight: "Kolom rechts invoegen",
		insertColLeft: "Kolom links invoegen",
		columnInfo: "Kolominformatie",
		hideColumn: "Kolom verbergen",
		deleteColumn: "Kolom verwijderen",
		ascending: "Oplopend",
		descending: "Aflopend",
		allRowsSelected: "Alle rijen zijn geselecteerd",
		clearSelection: "Duidelijke selectie"
	},
	timePicker: {
		hours: "Uur",
		minutes: "Minuten",
		seconds: "Seconden"
	},
	treeSelect: {
		noOptions: "Geen opties"
	}
};
var nlTranslations = {
	neetoui: neetoui$2
};

var neetoui$1 = {
	blockNavigation: {
		alertMessage: "Wszystkie niezapisane zmiany zostaną utracone. Tego nie można cofnąć.",
		submitButtonLabel: "Odrzucać zmiany",
		alertTitle: "masz niezapisane zmiany"
	},
	actionBlock: {
		cancel: "Anulować",
		saveChanges: "Zapisz zmiany"
	},
	colorPicker: {
		recentlyUsed: "Ostatnio używany"
	},
	datePicker: {
		today: "Dzisiaj"
	},
	table: {
		insertColRight: "Wstaw kolumnę po prawej stronie",
		insertColLeft: "Wstaw kolumnę po lewej stronie",
		columnInfo: "Informacje o kolumnie",
		hideColumn: "Ukryj kolumnę",
		deleteColumn: "Usuń kolumnę",
		ascending: "Rosnąco",
		descending: "Malejąco",
		allRowsSelected: "Wszystkie wiersze są zaznaczone",
		clearSelection: "Wyczyść wybór"
	},
	timePicker: {
		hours: "godziny",
		minutes: "Minuty",
		seconds: "sekundy"
	},
	treeSelect: {
		noOptions: "Brak opcji"
	}
};
var plTranslations = {
	neetoui: neetoui$1
};

var neetoui = {
	blockNavigation: {
		alertMessage: "Todas as suas alterações não salvas serão perdidas. Isso não pode ser desfeito.",
		submitButtonLabel: "Descartar alterações",
		alertTitle: "Você tem alterações não salvas"
	},
	actionBlock: {
		cancel: "Cancelar",
		saveChanges: "Salvar alterações"
	},
	colorPicker: {
		recentlyUsed: "Usado recentemente"
	},
	datePicker: {
		today: "Hoje"
	},
	table: {
		insertColRight: "Inserir coluna à direita",
		insertColLeft: "Inserir coluna à esquerda",
		columnInfo: "Informações da coluna",
		hideColumn: "Ocultar coluna",
		deleteColumn: "Excluir coluna",
		ascending: "Crescente",
		descending: "Decrescente",
		allRowsSelected: "Todas as linhas estão selecionadas",
		clearSelection: "Limpar seleção"
	},
	timePicker: {
		hours: "Horas",
		minutes: "Minutos",
		seconds: "Segundos"
	},
	treeSelect: {
		noOptions: "Sem opções"
	}
};
var ptTranslations = {
	neetoui: neetoui
};

/* eslint-disable import/extensions */
var resources = {
  en: {
    translation: en.enTranslations
  },
  es: {
    translation: esTranslations
  },
  fr: {
    translation: frTranslations
  },
  de: {
    translation: deTranslations
  },
  nl: {
    translation: nlTranslations
  },
  pl: {
    translation: plTranslations
  },
  pt: {
    translation: ptTranslations
  }
};

/* eslint-disable @bigbinary/neeto/file-name-and-export-name-standards */
/* eslint-disable import/extensions */

var initializeI18n = function initializeI18n() {
  var language = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "en";
  i18n.use(reactI18next.initReactI18next).init({
    resources: resources,
    lang: language,
    fallbackLng: "en",
    interpolation: {
      escapeValue: false
    }
  });
  return i18n;
};

var TranslationProvider = function TranslationProvider(_ref) {
  var children = _ref.children,
    language = _ref.language;
  var i18n = initializeI18n(language);
  React.useEffect(function () {
    if (!language || i18n.language === language) return;
    i18n.changeLanguage(language);
  }, [language]);
  return /*#__PURE__*/React.createElement(reactI18next.I18nextProvider, {
    i18n: i18n
  }, children);
};

module.exports = TranslationProvider;
//# sourceMappingURL=TranslationProvider.js.map
