'use strict';

var _ConfigProvider = require('antd/lib/config-provider');
var _Tree = require('antd/lib/tree');
var _extends = require('@babel/runtime/helpers/extends');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _objectWithoutProperties = require('@babel/runtime/helpers/objectWithoutProperties');
var React = require('react');
var classnames = require('classnames');
var reactI18next = require('react-i18next');
var constants = require('./constants.js');
var index = require('./index-Ci1VcKxO.js');
var neetoIcons = require('@bigbinary/neeto-icons');
require('antd/locale/de_DE');
require('antd/locale/en_US');
require('antd/locale/es_ES');
require('antd/locale/fr_FR');
require('antd/locale/nl_NL');
require('antd/locale/pl_PL');
require('antd/locale/pt_PT');
require('@babel/runtime/helpers/slicedToArray');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('@bigbinary/neeto-cist');
require('qs');
require('ramda');
require('./en-CPeHe9Ab.js');
require('@babel/runtime/helpers/toConsumableArray');
require('dayjs');
require('dayjs/plugin/localeData');
require('dayjs/plugin/utc');
require('dayjs/plugin/weekday');
require('dayjs/plugin/weekOfYear');

var SwitcherIcon = function SwitcherIcon(_ref) {
  var expanded = _ref.expanded;
  return expanded ? /*#__PURE__*/React.createElement(neetoIcons.Down, {
    size: 16
  }) : /*#__PURE__*/React.createElement(neetoIcons.Right, {
    size: 16
  });
};

var _excluded = ["componentToken"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var Tree = function Tree(_ref) {
  var componentToken = _ref.componentToken,
    props = _objectWithoutProperties(_ref, _excluded);
  var _useTranslation = reactI18next.useTranslation(),
    i18n = _useTranslation.i18n;
  return /*#__PURE__*/React.createElement(_ConfigProvider, {
    locale: constants.ANTD_LOCALE[i18n.language || "en"],
    theme: {
      token: _objectSpread({}, index.ANT_DESIGN_GLOBAL_TOKEN_OVERRIDES),
      components: {
        Tree: _objectSpread({
          directoryNodeSelectedBg: "rgb(var(--neeto-ui-primary-500))",
          directoryNodeSelectedColor: "rgb(var(--neeto-ui-white))",
          nodeHoverBg: "rgb(var(--neeto-ui-gray-100))",
          nodeSelectedBg: "rgb(var(--neeto-ui-primary-100))"
        }, componentToken)
      }
    }
  }, /*#__PURE__*/React.createElement(_Tree, _extends({
    switcherIcon: SwitcherIcon
  }, props, {
    className: classnames("neeto-ui-tree", props.className)
  })));
};

module.exports = Tree;
//# sourceMappingURL=Tree.js.map
