'use strict';

var _ConfigProvider = require('antd/lib/config-provider');
var _TreeSelect = require('antd/lib/tree-select');
var _extends = require('@babel/runtime/helpers/extends');
var _defineProperty = require('@babel/runtime/helpers/defineProperty');
var _objectWithoutProperties = require('@babel/runtime/helpers/objectWithoutProperties');
var React = require('react');
var classnames = require('classnames');
var neetoIcons = require('@bigbinary/neeto-icons');
var reactI18next = require('react-i18next');
var index = require('./index-Ci1VcKxO.js');
var constants = require('./constants.js');
var Label = require('./Label.js');
require('@babel/runtime/helpers/slicedToArray');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('@bigbinary/neeto-cist');
require('qs');
require('ramda');
require('./en-CPeHe9Ab.js');
require('@babel/runtime/helpers/toConsumableArray');
require('dayjs');
require('dayjs/plugin/localeData');
require('dayjs/plugin/utc');
require('dayjs/plugin/weekday');
require('dayjs/plugin/weekOfYear');
require('antd/locale/de_DE');
require('antd/locale/en_US');
require('antd/locale/es_ES');
require('antd/locale/fr_FR');
require('antd/locale/nl_NL');
require('antd/locale/pl_PL');
require('antd/locale/pt_PT');
require('./Button.js');
require('react-router-dom');
require('./Spinner.js');
require('./Tooltip.js');
require('@tippyjs/react');
require('tippy.js');
require('./Popover.js');
require('./Typography.js');

var _excluded = ["allowClear", "className", "disabled", "error", "fieldNames", "label", "onChange", "placeholder", "required", "showSearch", "size", "suffixIcon", "switcherIcon", "treeData", "treeDataSimpleMode", "value", "popupClassName"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var TreeSelect = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var _fieldNames$label;
  var allowClear = _ref.allowClear,
    className = _ref.className,
    _ref$disabled = _ref.disabled,
    disabled = _ref$disabled === void 0 ? false : _ref$disabled,
    error = _ref.error,
    fieldNames = _ref.fieldNames,
    _ref$label = _ref.label,
    label = _ref$label === void 0 ? "" : _ref$label,
    onChange = _ref.onChange,
    _ref$placeholder = _ref.placeholder,
    placeholder = _ref$placeholder === void 0 ? "" : _ref$placeholder,
    _ref$required = _ref.required,
    required = _ref$required === void 0 ? false : _ref$required,
    _ref$showSearch = _ref.showSearch,
    showSearch = _ref$showSearch === void 0 ? false : _ref$showSearch,
    _ref$size = _ref.size,
    size = _ref$size === void 0 ? "middle" : _ref$size,
    suffixIcon = _ref.suffixIcon,
    switcherIcon = _ref.switcherIcon,
    treeData = _ref.treeData,
    _ref$treeDataSimpleMo = _ref.treeDataSimpleMode,
    treeDataSimpleMode = _ref$treeDataSimpleMo === void 0 ? true : _ref$treeDataSimpleMo,
    value = _ref.value,
    popupClassName = _ref.popupClassName,
    otherProps = _objectWithoutProperties(_ref, _excluded);
  var _useTranslation = reactI18next.useTranslation(),
    t = _useTranslation.t,
    i18n = _useTranslation.i18n;
  var SuffixIcon = suffixIcon !== null && suffixIcon !== void 0 ? suffixIcon : neetoIcons.Down;
  var SwitcherIcon = switcherIcon !== null && switcherIcon !== void 0 ? switcherIcon : neetoIcons.Down;
  return /*#__PURE__*/React.createElement(_ConfigProvider, {
    locale: constants.ANTD_LOCALE[i18n.language || "en"],
    theme: {
      token: _objectSpread({}, index.ANT_DESIGN_GLOBAL_TOKEN_OVERRIDES),
      components: {
        TreeSelect: {
          nodeHoverBg: "rgb(var(--neeto-ui-gray-100))",
          nodeSelectedBg: "rgb(var(--neeto-ui-primary-500))",
          // Global overrides
          colorBgElevated: "rgb(var(--neeto-ui-white))"
        }
      }
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "neeto-ui-input__wrapper"
  }, label && /*#__PURE__*/React.createElement(Label, {
    required: required,
    "data-testid": "treeselect-label"
  }, label), /*#__PURE__*/React.createElement(_TreeSelect, _extends({
    allowClear: allowClear,
    disabled: disabled,
    fieldNames: fieldNames,
    onChange: onChange,
    placeholder: placeholder,
    ref: ref,
    showSearch: showSearch,
    size: size,
    treeData: treeData,
    treeDataSimpleMode: treeDataSimpleMode,
    "data-cy": "neeto-ui-tree-select-wrapper",
    dropdownStyle: {
      zIndex: 100000
    },
    suffixIcon: /*#__PURE__*/React.createElement(SuffixIcon, null),
    treeNodeFilterProp: (_fieldNames$label = fieldNames === null || fieldNames === void 0 ? void 0 : fieldNames.label) !== null && _fieldNames$label !== void 0 ? _fieldNames$label : "label",
    value: value || undefined,
    className: classnames("neeto-ui-tree-select__wrapper", className, {
      "neeto-ui-tree-select__error": error
    }),
    notFoundContent:
    /*#__PURE__*/
    // eslint-disable-next-line @bigbinary/neeto/hard-coded-strings-should-be-localized
    React.createElement("div", {
      className: "neeto-ui-text-center neeto-ui-p-1"
    }, index.getLocale(i18n, t, "neetoui.treeSelect.noOptions")),
    popupClassName: classnames("neeto-ui-tree-select-dropdown", popupClassName),
    switcherIcon: function switcherIcon(_ref2) {
      var className = _ref2.className,
        style = _ref2.style,
        onMouseMove = _ref2.onMouseMove,
        id = _ref2.id,
        title = _ref2.title;
      return /*#__PURE__*/React.createElement("div", {
        className: className,
        id: id,
        onMouseMove: onMouseMove,
        style: style,
        title: title
      }, /*#__PURE__*/React.createElement(SwitcherIcon, null));
    }
  }, otherProps)), error && /*#__PURE__*/React.createElement("p", {
    className: "neeto-ui-input__error",
    "data-testid": "treeselect-error"
  }, error)));
});
TreeSelect.displayName = "TreeSelect";

module.exports = TreeSelect;
//# sourceMappingURL=TreeSelect.js.map
