'use strict';

var _extends = require('@babel/runtime/helpers/extends');
var React = require('react');
var classnames = require('classnames');
var formik = require('formik');
var reactI18next = require('react-i18next');
var Button = require('../Button.js');
var index = require('../index-Ci1VcKxO.js');
var formik_Button = require('./Button.js');
require('@babel/runtime/helpers/defineProperty');
require('@babel/runtime/helpers/objectWithoutProperties');
require('react-router-dom');
require('../Spinner.js');
require('../Tooltip.js');
require('@babel/runtime/helpers/slicedToArray');
require('@tippyjs/react');
require('tippy.js');
require('@babel/runtime/helpers/classCallCheck');
require('@babel/runtime/helpers/createClass');
require('@bigbinary/neeto-cist');
require('qs');
require('ramda');
require('../en-CPeHe9Ab.js');
require('@babel/runtime/helpers/toConsumableArray');
require('dayjs');
require('dayjs/plugin/localeData');
require('dayjs/plugin/utc');
require('dayjs/plugin/weekday');
require('dayjs/plugin/weekOfYear');

var POSITIONS = {
  left: "left",
  right: "right"
};
var ActionBlock = function ActionBlock(_ref) {
  var className = _ref.className,
    submitButtonProps = _ref.submitButtonProps,
    cancelButtonProps = _ref.cancelButtonProps,
    isFormSubmitting = _ref.isSubmitting,
    _ref$position = _ref.position,
    position = _ref$position === void 0 ? POSITIONS.left : _ref$position;
  var _useTranslation = reactI18next.useTranslation(),
    t = _useTranslation.t,
    i18n = _useTranslation.i18n;
  var _useFormikContext = formik.useFormikContext(),
    handleReset = _useFormikContext.handleReset,
    isFormikSubmitting = _useFormikContext.isSubmitting,
    dirty = _useFormikContext.dirty;
  var isSubmitting = isFormSubmitting !== null && isFormSubmitting !== void 0 ? isFormSubmitting : isFormikSubmitting;
  var isButtonPositionRight = position === POSITIONS.right;
  var cancelButton = /*#__PURE__*/React.createElement(Button, _extends({
    "data-cy": "cancel-button",
    "data-test-id": "cancel-button",
    disabled: isSubmitting,
    label: index.getLocale(i18n, t, "neetoui.actionBlock.cancel"),
    style: "text",
    onClick: handleReset,
    onMouseDown: function onMouseDown(e) {
      return e.preventDefault();
    }
  }, cancelButtonProps));
  var submitButton = /*#__PURE__*/React.createElement(formik_Button, _extends({
    "data-cy": "save-changes-button",
    "data-test-id": "save-changes-button",
    disabled: isSubmitting || !dirty,
    label: index.getLocale(i18n, t, "neetoui.actionBlock.saveChanges"),
    loading: isSubmitting,
    style: "primary",
    type: "submit"
  }, submitButtonProps));
  return /*#__PURE__*/React.createElement("div", {
    className: classnames(["neeto-ui-action-block__wrapper", {
      "justify-end": isButtonPositionRight
    }, className])
  }, isButtonPositionRight ? /*#__PURE__*/React.createElement(React.Fragment, null, cancelButton, submitButton) : /*#__PURE__*/React.createElement(React.Fragment, null, submitButton, cancelButton));
};

module.exports = ActionBlock;
//# sourceMappingURL=ActionBlock.js.map
