'use strict';

var _extends = require('@babel/runtime/helpers/extends');
var _objectWithoutProperties = require('@babel/runtime/helpers/objectWithoutProperties');
var React = require('react');
var formik = require('formik');
var ramda = require('ramda');
var Button = require('../Button.js');
require('@babel/runtime/helpers/defineProperty');
require('classnames');
require('react-router-dom');
require('../Spinner.js');
require('../Tooltip.js');
require('@babel/runtime/helpers/slicedToArray');
require('@tippyjs/react');
require('tippy.js');

var _excluded = ["disabled"];
var FormikButton = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var disabled = _ref.disabled,
    otherProps = _objectWithoutProperties(_ref, _excluded);
  var _useFormikContext = formik.useFormikContext(),
    handleSubmit = _useFormikContext.handleSubmit,
    isSubmitting = _useFormikContext.isSubmitting,
    values = _useFormikContext.values,
    initialValues = _useFormikContext.initialValues,
    isValid = _useFormikContext.isValid;
  var isDisabled = disabled !== null && disabled !== void 0 ? disabled : isSubmitting || ramda.equals(values, initialValues);
  return /*#__PURE__*/React.createElement(Button, _extends({
    ref: ref,
    disabled: isDisabled,
    loading: isSubmitting && isValid,
    onClick: handleSubmit
  }, otherProps));
});
FormikButton.displayName = "FormikButton";

module.exports = FormikButton;
//# sourceMappingURL=Button.js.map
