import _extends from '@babel/runtime/helpers/extends';
import React__default from 'react';
import classnames from 'classnames';
import { useFormikContext } from 'formik';
import { useTranslation } from 'react-i18next';
import Button from '../Button.js';
import { g as getLocale } from '../index-C9RIWUPw.js';
import FormikButton from './Button.js';
import '@babel/runtime/helpers/defineProperty';
import '@babel/runtime/helpers/objectWithoutProperties';
import 'react-router-dom';
import '../Spinner.js';
import '../Tooltip.js';
import '@babel/runtime/helpers/slicedToArray';
import '@tippyjs/react';
import 'tippy.js';
import '@babel/runtime/helpers/classCallCheck';
import '@babel/runtime/helpers/createClass';
import '@bigbinary/neeto-cist';
import 'qs';
import 'ramda';
import '../en-D0AIwLkS.js';
import '@babel/runtime/helpers/toConsumableArray';
import 'dayjs';
import 'dayjs/plugin/localeData';
import 'dayjs/plugin/utc';
import 'dayjs/plugin/weekday';
import 'dayjs/plugin/weekOfYear';

var POSITIONS = {
  left: "left",
  right: "right"
};
var ActionBlock = function ActionBlock(_ref) {
  var className = _ref.className,
    submitButtonProps = _ref.submitButtonProps,
    cancelButtonProps = _ref.cancelButtonProps,
    isFormSubmitting = _ref.isSubmitting,
    _ref$position = _ref.position,
    position = _ref$position === void 0 ? POSITIONS.left : _ref$position;
  var _useTranslation = useTranslation(),
    t = _useTranslation.t,
    i18n = _useTranslation.i18n;
  var _useFormikContext = useFormikContext(),
    handleReset = _useFormikContext.handleReset,
    isFormikSubmitting = _useFormikContext.isSubmitting,
    dirty = _useFormikContext.dirty;
  var isSubmitting = isFormSubmitting !== null && isFormSubmitting !== void 0 ? isFormSubmitting : isFormikSubmitting;
  var isButtonPositionRight = position === POSITIONS.right;
  var cancelButton = /*#__PURE__*/React__default.createElement(Button, _extends({
    "data-cy": "cancel-button",
    "data-test-id": "cancel-button",
    disabled: isSubmitting,
    label: getLocale(i18n, t, "neetoui.actionBlock.cancel"),
    style: "text",
    onClick: handleReset,
    onMouseDown: function onMouseDown(e) {
      return e.preventDefault();
    }
  }, cancelButtonProps));
  var submitButton = /*#__PURE__*/React__default.createElement(FormikButton, _extends({
    "data-cy": "save-changes-button",
    "data-test-id": "save-changes-button",
    disabled: isSubmitting || !dirty,
    label: getLocale(i18n, t, "neetoui.actionBlock.saveChanges"),
    loading: isSubmitting,
    style: "primary",
    type: "submit"
  }, submitButtonProps));
  return /*#__PURE__*/React__default.createElement("div", {
    className: classnames(["neeto-ui-action-block__wrapper", {
      "justify-end": isButtonPositionRight
    }, className])
  }, isButtonPositionRight ? /*#__PURE__*/React__default.createElement(React__default.Fragment, null, cancelButton, submitButton) : /*#__PURE__*/React__default.createElement(React__default.Fragment, null, submitButton, cancelButton));
};

export { ActionBlock as default };
//# sourceMappingURL=ActionBlock.js.map
