import _extends from '@babel/runtime/helpers/extends';
import _objectWithoutProperties from '@babel/runtime/helpers/objectWithoutProperties';
import React__default, { forwardRef } from 'react';
import { useFormikContext } from 'formik';
import { equals } from 'ramda';
import Button from '../Button.js';
import '@babel/runtime/helpers/defineProperty';
import 'classnames';
import 'react-router-dom';
import '../Spinner.js';
import '../Tooltip.js';
import '@babel/runtime/helpers/slicedToArray';
import '@tippyjs/react';
import 'tippy.js';

var _excluded = ["disabled"];
var FormikButton = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var disabled = _ref.disabled,
    otherProps = _objectWithoutProperties(_ref, _excluded);
  var _useFormikContext = useFormikContext(),
    handleSubmit = _useFormikContext.handleSubmit,
    isSubmitting = _useFormikContext.isSubmitting,
    values = _useFormikContext.values,
    initialValues = _useFormikContext.initialValues,
    isValid = _useFormikContext.isValid;
  var isDisabled = disabled !== null && disabled !== void 0 ? disabled : isSubmitting || equals(values, initialValues);
  return /*#__PURE__*/React__default.createElement(Button, _extends({
    ref: ref,
    disabled: isDisabled,
    loading: isSubmitting && isValid,
    onClick: handleSubmit
  }, otherProps));
});
FormikButton.displayName = "FormikButton";

export { FormikButton as default };
//# sourceMappingURL=Button.js.map
