import _extends from '@babel/runtime/helpers/extends';
import _slicedToArray from '@babel/runtime/helpers/slicedToArray';
import _objectWithoutProperties from '@babel/runtime/helpers/objectWithoutProperties';
import React__default, { forwardRef } from 'react';
import { useField, useFormikContext, getIn } from 'formik';
import { dissoc } from 'ramda';
import TreeSelect from '../TreeSelect.js';
import 'antd/lib/config-provider';
import 'antd/lib/tree-select';
import '@babel/runtime/helpers/defineProperty';
import 'classnames';
import '@bigbinary/neeto-icons';
import 'react-i18next';
import '../index-C9RIWUPw.js';
import '@babel/runtime/helpers/classCallCheck';
import '@babel/runtime/helpers/createClass';
import '@bigbinary/neeto-cist';
import 'qs';
import '../en-D0AIwLkS.js';
import '@babel/runtime/helpers/toConsumableArray';
import 'dayjs';
import 'dayjs/plugin/localeData';
import 'dayjs/plugin/utc';
import 'dayjs/plugin/weekday';
import 'dayjs/plugin/weekOfYear';
import '../constants.js';
import 'antd/locale/de_DE';
import 'antd/locale/en_US';
import 'antd/locale/es_ES';
import 'antd/locale/fr_FR';
import 'antd/locale/nl_NL';
import 'antd/locale/pl_PL';
import 'antd/locale/pt_PT';
import '../Label.js';
import '../Button.js';
import 'react-router-dom';
import '../Spinner.js';
import '../Tooltip.js';
import '@tippyjs/react';
import 'tippy.js';
import '../Popover.js';
import '../Typography.js';

var _excluded = ["name"];
var FormikTreeSelect = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var name = _ref.name,
    otherProps = _objectWithoutProperties(_ref, _excluded);
  var _useField = useField(name),
    _useField2 = _slicedToArray(_useField, 3),
    field = _useField2[0],
    meta = _useField2[1],
    _useField2$ = _useField2[2],
    setValue = _useField2$.setValue,
    setTouched = _useField2$.setTouched;
  var _useFormikContext = useFormikContext(),
    _useFormikContext$sta = _useFormikContext.status,
    status = _useFormikContext$sta === void 0 ? {} : _useFormikContext$sta,
    setStatus = _useFormikContext.setStatus;
  var fieldStatus = getIn(status, name);
  return /*#__PURE__*/React__default.createElement(TreeSelect, _extends({
    ref: ref,
    error: meta.error || fieldStatus || "",
    name: field.name,
    value: field.value,
    onBlur: function onBlur() {
      return setTouched(true);
    },
    onChange: function onChange(value) {
      setStatus(dissoc(name, status));
      setValue(value);
    }
  }, otherProps));
});
FormikTreeSelect.displayName = "TreeSelect";

export { FormikTreeSelect as default };
//# sourceMappingURL=TreeSelect.js.map
